#ifndef MONOMIAL_H_
#define MONOMIAL_H_

#ifndef DEBUGGING
#define DEBUGGING 0
#endif

#include "Variable.h"
#include "functions.h"
#include <vector>

struct Monomial {

  int size;  
  // Rational LC;
  // bool valid;
  Variable* Variables;
  int* Exponents;
  // the default constructor
Monomial():Variables(NULL), Exponents(NULL){
  // set the Monomial to the constant monomial
  // with coefficient 0
  // LC = Rational();
  size = 0;
  Variables = NULL;
  Exponents = NULL;
  /* std::cout << "Entering Monomial Default Constructor\n"
	    << "setting Variables = Exponents = NULL \n"
	    << "Leaving Monomial Default Constructor\n";
  */
}
  // Deep Copy Constructor
  Monomial(const Monomial & M){
    // std::cout << "Entering deep copy constructor" << std::endl;
    //    this->LC = M.LC;
    if (Variables != NULL){
      delete[] Variables;
      Variables = NULL;
    }
    if(Exponents != NULL){
      delete[] Exponents;
      Exponents = NULL;
    }
    this->size = M.size;
      
#ifdef debugmem
      std::cout << "\n******\n\nallocating Variables\n\n******\n";
#endif
    this->Variables = new Variable[size];
      
#ifdef debugmem
      std::cout << "\n******\n\nallocating Exponents\n\n******\n";
#endif
    this->Exponents = new int[size];
    for (int i = 0; i < size; ++i){
      this->Variables[i] = M.Variables[i];
      this->Exponents[i] = M.Exponents[i];      
    }
    //    std::cout << "Leaving deep copy constructor" << std::endl;
  }
  ~Monomial(){
    if (Variables != NULL){ 
      delete[] Variables;
      // size = 0;
      Variables = NULL;
    }
    if (Exponents != NULL){

      delete[] Exponents;
      Exponents = NULL;
    }
    size = 0;
  }
  /* void SetLC(Rational r){
    LC = r;
  } // end destructor
  */
  /*Monomial(std::string s){
    std::cout << "Entering Monomial(std::string s)" << std::endl;
    Monomial M;
    M.Set(s);
    //Set(s);
    size = M.size;
    LC = M.LC;
    Variables = M.Variables;
    std::cout << "Leaving Monomial(std::string s)" << std::endl;
  }
  */
Monomial(Rational r, Variable* the_array, int* exps, int s):Variables(NULL),Exponents(NULL){
    if (Variables != NULL){
      // std::cout << "Variables != NULL\n";
      delete[] Variables;
    }
    if (Exponents != NULL){
      // std::cout << "Exponents != NULL\n";
      delete[] Exponents;
    }
    size = s;
#ifdef debugmem
    std::cout << "\n******\n\nallocating Variables\n\n******\n";
#endif
    Variables = new Variable[size];
#ifdef debugmem
    std::cout << "\n******\n\nallocating Exponents\n\n******\n";
#endif
    Exponents = new int[size];
    for (int i = 0; i < size; ++i){
      Variables[i] = the_array[i];
      Exponents[i] = exps[i];
    }
    //  Variables = the_array;
    // go ahead and sort the array, just in case
    QuickSort<Variable, int>(Variables, size, 0, size - 1, Exponents);
  }
  /*  void QuickSort(int m, int n){
    // a function to sort the Variable array
   
    if(DEBUGGING){
      std::cout << "Entering Monomial::QuickSort(int m, int n)" << std::endl;
    }    
    int i,j,k;
    Variable key;
    if( m < n){
      k = choose_pivot(m,n); // choose the location of the pivot element
                             // pivot position chosen is the average of m and n 
      swap(m,k); // swap the m'th and the k'th element
      
      key = Variables[m]; // choose the pivot element
      i = m+1; 
      j = n;
      while(i <= j){
	while((i <= n) && (Variables[i] <= key))
	  i++;
	while((j >= m) && (Variables[j] > key))
	  j--;
	if( i < j)
	  swap(i,j);
      }
      // swap two elements
      swap(m,j);
      // recursively sort the lesser list
      QuickSort(m,j-1);
      // recursively sort the greater list
      QuickSort(j+1,n);
    }
    if(DEBUGGING){
      std::cout << "Leaving Monomial::QuickSort(int m, int n)" << std::endl;
    }
  }
  
  int choose_pivot(int i,int j ){
    return((i+j) /2);
  }
  */

  void Insert(Variable v){
   if(DEBUGGING){
    std::cout << "Entering Monomial::Insert(Variable v)" << std::endl;
   }
    // insert a new variable into the monomial
    // in the appropriate position in the array
    
    // find the location of where the variable
    // should go
    
    int location = Find(v, 0, size - 1);
    // test if variable is not already in the array
    if (Variables[location] != v){
      size++;
      if(DEBUGGING){
	std::cout << "Creating a new Variable pointer tmp" << std::endl;
      }
#ifdef debugmem
        std::cout << "\n******\n\nallocating tmp\n\n******\n";
#endif
      Variable* tmp = new Variable[size];
      for (int i = 0; i < location; ++i){
          tmp[i] = Variables[i];
      }
      tmp[location] = v;
      for (int i = location+1; i < size; ++i){
	tmp[i] = Variables[i-1];
      }
      if(DEBUGGING){
	std::cout << "Delete[] Variables" << std::endl;
      }
      delete[] Variables;
      if(DEBUGGING){
	std::cout << "Setting Variables to tmp" << std::endl;
      }
      Variables = tmp;
      if(DEBUGGING){
	std::cout << "Setting tmp to NULL";
      }
      tmp = NULL;
    }
    if(DEBUGGING){
      std::cout << "Leaving Monomial::Insert(Variable v)" << std::endl;
    }
  }
  int Find(Variable v, int beginning, int end){
    int s = end - beginning + 1;
    if (s == 1){
      if (v <= Variables[beginning]){ // give ordering
                                      // preference to
                                      // current variable
	return beginning;
      }
      else
	return beginning+1;
    }
    // go to recursive case
    int middle = (beginning + end)/2;
    if (Variables[middle] < v){
      return Find(v, beginning, middle-1);
    }
    else
      return Find(v, middle, end);
  }
  void Swap(int i, int j){
    // make sure the values are in the bounds
    if (i < size && j < size){
      Variable tmp = Variables[i];
      Variables[i] = Variables[j];
      Variables[j] = tmp;
    }
  }
  int GetSize(){ return size; }
  void Set(std::string s){

    if(DEBUGGING){
      std::cout << "Entering Monomial::Set(std::string s)" << std::endl;
    }
    s = removeChar(s, ' ');
    /* if (s[0] == '*' || s[0] == '+'){
      std::cout << "First character was a * or a +"
		<< " calling Monomial::Set(" << s.substr(1) << ")"
		<< std::endl;
      Set(s.substr(1));
    }*/

    if(DEBUGGING){
      std::cout << "The monomial string to parse is : " << s << std::endl;
    }
    // first off, test for a balanced expression
    if (!isBalanced(s)){
      //  errorMessage(2);
      std::cerr << "Monomial string : '" << s 
		<< "' is not a balanced expression."
		<< std::endl;
      // go ahead and set Monomial to constant monomial
      // with LC = 0
      if (this->Variables != NULL){
	// go ahead and delete the array
	// if it was already set
	if(DEBUGGING){
	  //  std::cout << "delete[] Variables" << std::endl;
	}
	delete[] this->Variables;
      }
      size = 0;
      if(DEBUGGING){
	std::cout << "Setting Variables = NULL" << std::endl;
      }
      this->Variables = NULL;
      // LC = 0;
    }
      if(this->Exponents != NULL){
          delete[] this->Exponents;
          this->Exponents = NULL;
      }
    /*
    // else{ // expression is balanced, so no problems, so far
      // get the leading coefficient
      //      string LCs = "";
      // char c = s[0];
      //  char c2 = s[1];
      // 
      // if (isalpha(c) || (c == '+' && isalpha(c2))){
      //	LCs = "1";
      // }
      // else if (c == '-' && isalpha(c2)){
      //	LCs = "-1";
      // }
      else{
	// LCs.append(s.substr(0,1));
	
	int neg = 0;
	//	int pos = 0;
	int sign_pos = 0;
	while (isdigit(s[index]) || s[index] == '/' || s[index] == '+'
	       || s[index] == '-'){
	  if (s[index] == '-'){
	    ++neg;
	  }
	  if (s[index] == '/' || isdigit(s[index])){
	    LCs.append(s.substr(index,1));
	  }
	  ++index;
	}
	string LCs2 = "";
	neg%=2;
	LCs2.append(( neg ? "-" : "+"));
	LCs2.append(LCs);
	LCs = LCs2;
      }
      // put the string on a buffer
      stringstream in;
      if(DEBUGGING){
	std::cout << "The LC string was : " << LCs << std::endl;
      }
      in << LCs;
      in >> LC;
      
      if(DEBUGGING){
	std::cout << "The LC is : " << LC << std::endl;
      }
    */
      // parse the rest of the string into variable pieces
      // allow any  character to be the variable name
      // parse abc as a_1^1b_1^1c^1 or a_{1}^{1}b_{1}^{1}c_{1}^{d}
      // so separate strings by letters i.e. use isAlpha(char c)

      // run through the string and set the locations
      // of the alpha characters

      std::vector<int> alpha_locs;
      
      for (int i = 0; i < s.size(); ++i){
	if (isalpha(s[i])){
	  alpha_locs.push_back(i);
	}
      }
      if(DEBUGGING){
	std::cout << "The number of alpha characters is : " << alpha_locs.size()
		  << std::endl;
      }
	// create the appropriate size for the variable array
      // if there are not any alpha characters, then it is constant
      // and so set size to 1 and and the monomial is the const
      if (alpha_locs.size() != 0){
	if(DEBUGGING){
	  std::cout << "The location of the alpha characters is : ";
	  
	  for (int i = 0; i < alpha_locs.size(); ++i){
	    std::cout << alpha_locs[i] << " ";
	  }
	  std::cout << std::endl;
	}	
	if (this->Variables != NULL){
	  if(DEBUGGING){
	    std::cout << "The error is here!"
		      << "  Attempting to delete Variables"
		      << " pointer because it is not NULL" << std::endl;
	  }
	  delete[] Variables;
	}
	if(DEBUGGING){
	  std::cout << "creating new Variable[" << alpha_locs.size() << "]" 
		    << std::endl;
	}
#ifdef debugmem
          std::cout << "\n******\n\nallocating Variables\n\n******\n";
#endif
	this->Variables = new Variable[alpha_locs.size()];
	size = alpha_locs.size();
#ifdef debugmem
          std::cout << "\n******\n\nallocating Exponents\n\n******\n";
#endif
          
	this->Exponents = new int[size];
	
	

	// then, pass the string to the variable parser for each token
	
	for (int i = 0; i < alpha_locs.size() -1; ++i){
	  
	  std::string current = s.substr(alpha_locs[i], 
					 alpha_locs[i+1] - (alpha_locs[i]) - 1);
	  /* std::cout << "current = the substring of '" << s << "' starting at "
		    << alpha_locs[i] << " with size " 
		    << alpha_locs[i+1] - (alpha_locs[i]) - 1
		    << std::endl;
	  */
	  int wedge_pos = current.find("^");
	  // std::cout << "original Current = " << current << std::endl;	 
	  if (wedge_pos != std::string::npos){
	    // set the exponent string, possible surrounded by () or {}
	    std::string exp_str = current.substr(wedge_pos+1);
	    // set the variable string to cut off at the ^
	
	    //	     std::cout << "original exp_str = " << exp_str << std::endl;
	    current = current.substr(0, wedge_pos);
	    // std::cout << "new current = "<< current << std::endl;

	    // get the exponent off of this
	    if (exp_str[0] == '{' || exp_str[0] == '('){
	      // expression is automatically balanced ...
	      int close_loc;
	      if (exp_str[0] == '{'){
		close_loc = exp_str.find('}');
	      }
	      else{
		close_loc = exp_str.find(')');
	      }
	      exp_str = exp_str.substr(1, close_loc -1); 
	      stringstream exp_ss;
	      exp_ss << exp_str;
	      int the_exp;
	      /*
		std::cout << "The exponent string is : "
			<< exp_str
			<< std::endl;
	      */
	      exp_ss >> the_exp;
	      this->Exponents[i] = the_exp;
	    }
	    else{ // was notsurrounded by ()
	      stringstream exp_ss;
	      std::string my_exp_str = "";
	      for (int h = 0; h < exp_str.size(); ++h){
		// count the number of negatives
		int neg_count = 0;
		if (isdigit(exp_str[h]) 
		    || exp_str[h] == '-' || exp_str[h] == '+'){
		  if (exp_str[h] == '-'){
		    ++neg_count;
		  }
		  if (isdigit(exp_str[h])){
		    my_exp_str.append(exp_str.substr(h,1));
		  }
		}
		exp_ss << (neg_count % 2 ? "-" : "");
	      }
	      exp_ss << my_exp_str;
	      int the_exp;
	      exp_ss >> the_exp;
	      this->Exponents[i] = the_exp;
	    }
	  }
	  else{ // found no ^, so Exponent is 1
	    Exponents[i] = 1;
	  }
	  
	  Variable v(current);
	  this->Variables[i] = v;
	  if (DEBUGGING){
	    std::cout << "setting the " << i << "'th variable in the monomial "
		      << "to " << v << std::endl;
	  }
	}
	// pass the string for the last variable
	
	// Variables[alpha_locs.size()-1] = v;
	
	if (this->Variables != NULL){ // not the constant monomial
	  // just go to the end of the string for the substring
	  // from the location of the last alpha character location
	  std::string current = s.substr(alpha_locs[alpha_locs.size()-1]);
	  // strip off the ^
	  int wedge_loc = current.find("^");
	  if (wedge_loc != std::string::npos){
	    // set the exponent string, possible surrounded by () or {}
	    std::string exp_str = current.substr(wedge_loc+1);
	    // set the variable string to cut off at the ^
	    //   std::cout << "Original exp_str = " << exp_str << std::endl;
	    current = current.substr(0, wedge_loc);
	    if (exp_str[0] == '{' || exp_str[0] == '('){
	      int close_loc;
	      if (exp_str[0] == '{'){
		close_loc = exp_str.find('}');
	      }
	      else{
		close_loc = exp_str.find(')');
	      }
	      exp_str = exp_str.substr(1, close_loc -1);
	      //    std::cout << "exp_str is now " << exp_str << std::endl;
	      stringstream exp_ss;
	      exp_ss << exp_str;
	      int the_exp;
	      exp_ss >> the_exp;
	      Exponents[size-1] = the_exp;
	    }
	    else{
	      // no ( or { found
	      stringstream exp_ss;
	      exp_ss << exp_str;
	      int the_exp;
	      exp_ss >> the_exp;
	      this->Exponents[size-1] = the_exp;
	    }
	  }
	  else{ // found no ^, so Exponent is 1
	    Exponents[size-1] = 1;
	  }
	  Variable v(current);
	  //Variable v(s.substr(alpha_locs[alpha_locs.size()-1])); 
	  Variables[size-1] = v;
	  if (DEBUGGING){
	    std::cout << "setting the " << size-1 
		      << "'th variable in the monomial "
		      << "to " << v << std::endl; 
	  }
	}
      }
      else{
	// set as the constant monomial

	if (this->Variables != NULL){
	  if(DEBUGGING){
	    std::cout << "delete[] Variables in Set" << std::endl;
	  }
	  delete[] this->Variables;
	  if(DEBUGGING){
	    std::cout << "Setting Variables = NULL" << std::endl;
	  }
	  this->Variables = NULL;
	}
	if (this->Exponents != NULL){
	  delete[] this->Exponents;
	  this->Exponents = NULL;
	}
	// LC is already set
	size = 0;
      } // set as constant monomial
  
    
    // Simplify the Monomial!
    // get rid of constant variables
    // and add exponents of variables that are the same
    // i.e. same var_name and same var_no

    Simplify();
    if(this->Variables != NULL){ // no need to sort if there are no variables
      QuickSort(this->Variables, size, 0, size-1, this->Exponents);
    }
    if(DEBUGGING){
      std::cout << "The Monomial string was : " << s << std::endl << std::endl;
      std::cout << "The Monomial was set to : " << toString() << std::endl;
      
      std::cout << "Leaving Monomial::Set(std::string s)" << std::endl;
    
    }
}
  
  void Simplify(){}
// first off, get rid of all of the constant variables
//  int size2 = size;
// for (int i = 0; i < size; ++i){
//  if (Variables[i].exp == 0){
//--size2;
//   }
// }
// if (size2){ // not the constant monomial
/* if (size != size2){
   Variable* tmp = new Variable[size2];
   int count = 0;
   for (int i = 0; i < size; ++i){
	if (Variables[i].exp !=0){
	tmp[count++] = Variables[i];
	}
	}
	// delete[] Variables
	if (Variables){
	delete[] Variables;
	Variables = NULL;
	}
	size = size2;
	// set Variables to tmp and tmp to NULL
	Variables = tmp;
	tmp = NULL;
	if (!size2)
	Variables = NULL;
	}*/




void output(){
  std::cout << toString(); 
}
  std::string toString(){
    
    stringstream s;
    Insert(s);
    return s.str();
  }
  void Extract(istream &sin) {
    // put whatever is on the stream into the string
    std::string the_string;
    sin >> the_string;
    
    Set(the_string);
    return;
  }

void Insert(ostream &sout){
    // std::cout << "Entering Monomial::Insert(ostream &sout)" << std::endl;
  // sout << LC;
    // cout << LC;
    // std::cout << "size = " << size << std::endl;
  std::stringstream myss;
  myss << "";
   for (int i = 0; i < size; ++i){
     //  if (myss.str().compare("") == 0){ // if myss is currently empty
     bool addstar = false;
     if (i != 0 & myss.str().compare("") != 0){ // myss is not empty & we are on a loop
       addstar = true;
     }
     
     if (Exponents[i] != 0){
       //   sout << Variables[i]; // don't output the variable if it has a 0 exponent
       myss << (addstar ? "*" : "") <<  Variables[i];
     }
      if (Exponents[i]!=1 & Exponents[i] != 0){
	/*	sout << "^("
	     << Exponents[i]
	     << ")";
      
	*/
	myss << "^("
	     << Exponents[i]
	     << ")";
      }
      // if (i != size-1){
	/*	sout  << "*";
	 */
      //      }
      

    //   cout << Variables[i];
    }
   if (size == 0){
     //  sout << "";
     myss << "";
   }
    
   sout << myss.str();
    // std::cout << std::endl;
    // std::cout << "Leaving Monomial::Insert(ostream &sout)" << std::endl;
    return;
  }

  bool isBalanced(std::string s){
  
    
    // return true for now
   return true;
  }
Monomial& operator=(const Monomial& m) {
  // std::cout << "Entering assignment operator " << std::endl;
if (this != &m) {  // make sure not same object      
      this->size = m.size;
      
      if (this->Variables != NULL){
	//	std::cout << "delete[] Variables in Mono assignment op"
	//	  << std::endl;
	delete[] this->Variables;
      }
      if (this->Exponents != NULL){
	delete[] this->Exponents;
      }
#ifdef debugmem
    std::cout << "\n******\n\nallocating Variables\n\n******\n";
#endif
      this->Variables = new Variable[size];
#ifdef debugmem
    std::cout << "\n******\n\nallocating Exponents\n\n******\n";
#endif
      this->Exponents = new int[size];
      // this->LC = m.LC;
      for (int i = 0; i < size; ++i){
	this->Variables[i] = m.Variables[i];
	this->Exponents[i] = m.Exponents[i];
      }
    }
  //  std::cout << "Leaving assignment operator" << std::endl;
  return *this;    // Return ref for multiple assignment
}  
  bool IsConstant(){
    return !size;
  }    
};  //end struct



ostream & operator << (ostream & sout, Monomial & m){

  m.Insert(sout);
  return sout;
}
istream & operator >> (istream & sin, Monomial & m){
  m.Extract(sin);
  return sin;
}



bool operator == (Monomial & m1, Monomial & m2){
  // std::cout << "Comparing " << m1.toString() 
  //  << " == " << m2.toString() 
  //<< std::endl;
  // first test if size of the monomials variable array is the same
  if (m1.size != m2.size){
    //   std::cout << " returning false" << std::endl;
    return false;
  }
  // otherwise, set size to be the size of the variable array
  int size = m1.size;
  for (int i = 0; i < size; ++i){
    if (m1.Variables[i] != m2.Variables[i]){
      //   std::cout << " returning false" << std::endl;
      return false;
    }
  }
  //  std::cout << " returning true" << std::endl;
  return true;
}

bool operator < ( Monomial &m1,  Monomial& m2){
  //  std::cout << "Comparing " << m1 << " < " << m2 << std::endl;
  if (!m1.size && m2.size){ // m2 is not constant var, m1 is const
                                      // const always biggest
    //  std::cout << " returning false" << std::endl;

    //  std::cout << m1 << " < " << m2 << std::endl;
    return false;
  }
  else if (m1.size && !m2.size){ // m1 is not const var, m2 is
                                           // const, const always bigger 
    //  std::cout << " returning true" << std::endl;
    //  std::cout << m1 << " < " << m2 << std::endl;
    return true;
  }
  else if (!m1.size && !m2.size){ // m1 and m2 are const
    //  std::cout << " returning false" << std::endl;
    //  std::cout << m1 << " < " << m2 << std::endl;
    return false;
  }
  else{ // neither are const
    // get the smaller of the two array sizes to
    // make sure we stay in bounds
    int s = m1.size < m2.size ? m1.size : m2.size;
    for (int i = 0; i < s; ++i){
      if (m1.Variables[i] < m2.Variables[i]){
	//	std::cout << " returning true" << std::endl;
	return true;
      }
      else if (m1.Variables[i] > m2.Variables[i]){
	//	std::cout << " returning false" << std::endl;
	return false;
      }
      // if they are the same ... go through the loop
    }
    // variable array was the same up to here
    // if they are the same size
    // return true
    if (m1.size == m2.size){
      //  std::cout << " returning false" << std::endl;
      return false;
    }
    else{
      //  std::cout << " returning true" << std::endl;
      return true;
    }
  }
}

bool operator <= (Monomial & m1, Monomial & m2){
  // std::cout << "Comparing " << m1 << " <= " << m2 << std::endl;
  return m1 < m2 | m1 == m2;
}

bool operator > (Monomial & m1, Monomial & m2){
  // std::cout << "Comparing " << m1 << " > " << m2 << std::endl;
  return m2 < m1;
}

bool operator >= (Monomial & m1, Monomial & m2){
  // std::cout << "Comparing " << m1 << " >= " << m2 << std::endl;
  return m2 < m1 | m2 == m1;
}

bool operator != (Monomial & m1, Monomial & m2){
  //  std::cout << "Comparing " << m1 << " != " << m2 << std::endl;
  return !(m1 == m2);
}


bool isBalanced(std::string s){


  // return true for now
  return true;
}


#endif
