#ifndef POLYNOMIAL_H_
#define POLYNOMIAL_H_

#include "Monomial.h"

#ifndef DEBUGGING
#define DEBUGGING 0
#endif

struct Polynomial {
  
  int size;
  Monomial* Monomials;
  Rational* LC;
  int GetSize(){
    return size;
  }
  Polynomial(Monomial* m, Rational* lc, int s){

    size = s;
#ifdef debugmem
      std::cout << "\n******\n\nallocating Monomials\n\n******\n";
#endif
    Monomials = new Monomial[size];
#ifdef debugmem
      std::cout << "\n******\n\nallocating LC\n\n******\n";
#endif
    LC = new Rational[size];
    for (int i = 0; i < size; ++i){
      Monomials[i] = m[i];
      LC[i] = lc[i];
    }

  }
  Polynomial(){ // set to const polynomial
    //if(DEBUGGING){
    //   std::cout << "Entering Polynomial()" << std::endl;
    //   std::cout << "Creating new Monomial[1]" << std::endl;
    // }
    // could set to 0 Polynomial ...
    Monomials = NULL;
    LC = NULL;
    //  std::cout << "setting size to 0" << std::endl;
    size = 0;
    /*
      Monomials = new Monomial[1];
      std::cout << "Setting Monomials[0]" << std::endl;
      Monomials[0] = Monomial();
      std::cout << "Creating new Rational[1]" << std::endl;
      LC = new Rational[1];
	 std::cout << "Setting Rational[0]" << std::endl;
	 LC[1] = 0;
	 size = 1;
    */
    // if(DEBUGGING){ 
    // std::cout << "Leaving Polynomial()" << std::endl;
    // }
  }
  // deep copy constructor
  Polynomial(const Polynomial & p){
    //  std::cout << "Entering deep copy constructor" << std::endl;
    
      /*if (size){
      delete[] this->Monomials;
      delete[] this->LC;
      this->Monomials = NULL;
      this->LC = NULL;
    }
       */
      if (this->Monomials != NULL){
          delete[] this->Monomials;
          this->Monomials = NULL;
      }
      if (this->LC != NULL){
          
          delete[] this->LC;
          this->LC = NULL;
      }
    this->size = p.size;
      
      
      
    this->Monomials = new Monomial[size];
    this->LC = new Rational[size];
    
    for (int i = 0; i < size; ++i){
      (this->Monomials)[i] = p.Monomials[i];
      (this->LC)[i] = p.LC[i];
    }
    //    std::cout << "Leaving deep copy constructor" << std::endl;
  }
  ~Polynomial(){
   
      
      if (this->Monomials != NULL){
          delete[] this->Monomials;
          this->Monomials = NULL;
      }
      if (this->LC != NULL){
          delete[] this->LC;
          this->LC = NULL;
      }
      size = 0;
      //if(DEBUGGING){
     //  std::cout << "Entering ~Polynomial()" << std::endl;
   //}
    //if (size){
    //  if(DEBUGGING){
	//	std::cout << "delete[] Monomials in destructor" << std::endl;
            
	//	for (int i = 0; i < size; ++i){
	//  std::cout << Monomials[i];
	//	}
	//	std::cout << std::endl;
    //  }
    //  delete[] Monomials;
    //  Monomials = NULL;
    //  delete[] LC;
    //  LC = NULL;
    //  size = 0;
   // }
   // if(DEBUGGING){
      //  std::cout << "Leaving ~Polynomial()" << std::endl;
   // }
  }
  

  void Swap(int i, int j){
    // make sure the values are in the bounds
    if (i < size && j < size){
      Monomial tmp = Monomials[i];
      Monomials[i] = Monomials[j];
      Monomials[j] = tmp;
    }
  }
  int choose_pivot(int i,int j ){
    return((i+j) /2);
  }





  void Insert(Monomial m, Rational lc = Rational(1)){
   if(DEBUGGING){
    std::cout << "Entering Polynomial::Insert(Monomial m)" << std::endl;
   }
    // insert a new monomial into the polynomial
    // in the appropriate position in the array
    
    // find the location of where the monomial
    // should go
    
   int location = Find(m, 0, size - 1);
   // test if variable is not already in the array
   if (Monomials[location] != m){
     size++;
     if(DEBUGGING){
       std::cout << "Creating a new Monomial pointer tmp" << std::endl;
     }
     Monomial* tmp = new Monomial[size];
     Rational* tmplc = new Rational[size];
     for (int i = 0; i < location; ++i){
       tmp[i] = Monomials[i];
       tmplc[i] = LC[i];
     }
     tmp[location] = m;
     tmplc[location] = lc;
     for (int i = location+1; i < size; ++i){
       tmp[i] = Monomials[i-1];
       tmplc[i] = LC[i-1];
     }
     if(DEBUGGING){
       std::cout << "Delete[] Monomials" << std::endl;
     }
     delete[] Monomials;
     delete[] LC;
     if(DEBUGGING){
       std::cout << "Setting Monomials to tmp" << std::endl;
     }
     Monomials = tmp;
     LC = tmplc;
     if(DEBUGGING){
       std::cout << "Setting tmp to NULL";
     }
     tmp = NULL;
     tmplc = NULL;
   }
   if(DEBUGGING){
     std::cout << "Leaving Polynomial::Insert(Monomial m)" << std::endl;
   }
  }
  int Find(Monomial m, int beginning, int end){
    int s = end - beginning + 1;
    if (s == 1){
      if (m <= Monomials[beginning]){ // give ordering
                                      // preference to
                                      // current monomial
	return beginning;
      }
      else
	return beginning+1;
    }
    // go to recursive case
    int middle = (beginning + end)/2;
    if (Monomials[middle] < m){
      return Find(m, beginning, middle-1);
    }
    else
      return Find(m, middle, end);
  }

 


  void Set(std::string s){
    if(DEBUGGING){
      std::cout << "Entering Polynomial::Set(std::string s)" << std::endl;
    }
    
    if (s == ""){
      if(DEBUGGING){
      std::cout << "Passing a Null string to be set" << std::endl;
      }
    }
    if(DEBUGGING){    
      std::cout << "The string we are trying to set is " << s << std::endl;
    }
    // remove all the ' '

    s = removeChar(s, ' ');
   
 
    // find the locations of all the plusses or minusses
    vector<int> delim_locs;
    // assume the starting position for parsing the string
    // is at 0
    // not at 0 if there is a space, or a {,(, [
    int starting = 0;

    if(DEBUGGING){
      std::cout << "The locations of the +'s and -'s in the polynomial string are :";
    }

     for (int i = 0; i < s.size(); ++i){
      if (s[i] == '+' || s[i] == '-'){
	delim_locs.push_back(i);
	if(DEBUGGING){    
	  std::cout << i << " ";
	}
      }
    }
     if(DEBUGGING){    
       std::cout << std::endl;
     }
    // go ahead and remove all the plusses and minusses
    // that do not separate tokens
    // if the plus or minus is before a _{, _, ^{, or ^
    
    // form a vector for all the 'good' delimiters
    vector<int> good_delims;
    
    // check if the first delimiter was found
    // at position 0 or 1

    // first make sure that there are elements in the delim vector

    if (delim_locs.size()){
      if (delim_locs[0] < 2){
	// first delimiter was found at 0 or 1
	if (delim_locs[0] != 0) {
	  // then delimiter was found at 1
	  // delimiter definitely essential
	  // so, test if previous character was a space
	  // 
	  // if it is a space, or a (,{,[, then set the starting location
	  // to 1 and do not add to the 'good' vector
	  if (s[0] == '{' || s[0] == '(' || s[0] == ']'){
	    starting = 1;
	  }
	  else{
	    good_delims.push_back(delim_locs[0]);
	  }
	}
	else{
	  // delimiter was found at 0
	  // do not add to the 'good' vector
	  // will end up passing a null string
	  // to the monomial parser
	  // not a good thing
	}
      }
      else{
	// delimiter is not found at 0 or 1
	// so do normal test to see if 'good'
	char c1 = s[delim_locs[0] - 1];
	char c2 = s[delim_locs[0] - 2];
	

	  // otherwise, we need to test if this is a 'good' delimiter
	  // to add to our 'good' vector
	  if ((c1 == '_') || (c1 == '^') || (c1 == '{')){
	    if (c1 == '{'){
	      // test if c2 is a _ or a ^
	      if (c2 == '^' || c2 == '_'){
		// it's not a good delimiter
	      }
	      else{
		// it is a good delimiter
		good_delims.push_back(delim_locs[0]);
	      }
	    }
	    // this is not a 'good' delimiter
	  }
	  else{
	    // delimiter should be 'good'
	    good_delims.push_back(delim_locs[0]);
	  }
 
      }
    }
    for (int i = 1; i < delim_locs.size(); ++i){
      // need to test if we're at the beginning
      if (delim_locs[i] > 1){
	// not at the beginning, so we're not out of range
	// when we set these two varaibles
	char c1 = s[delim_locs[i] - 1];
	char c2 = s[delim_locs[i] - 2]; 
	// first off
	// test if previous delimiter location
	// is one before current one
	if (delim_locs[i-1] + 1 ==delim_locs[i]){
	  // well, don't add this one to the 'good' vector
	  // something like --, -+, ++, +-
	}
	else{
	  // otherwise, we need to test if this is a 'good' delimiter
	  // to add to our 'good' vector
	  if ((c1 == '_') || (c1 == '^') || (c1 == '{')){
	    if (c1 == '{'){
	      // test if c2 is a _ or a ^
	      if (c2 == '^' || c2 == '_'){
		// its's not a good delimiter
	      }
	      else{
		// it is a good delimiter
		good_delims.push_back(delim_locs[i]);
	      }
	    }
	    // this is not a 'good' delimiter
	  }
	  else{
	    // delimiter should be 'good'
	    good_delims.push_back(delim_locs[i]);
	  }	  
	}	
      }
      else{
	// well, the delimeter is at the beginning
	// we already looked at the very first delimiter
	// so, this can only happen if
	// the second delimiter is right after the first one
	// i.e. delims_loc[1] == 1 has to be true
	// so don't add to the 'good' vector
	// may have something like --
	// show up, in which case we want the 
	// monomial parser to make that into a positive
	// value
      }      
    }

    // so we have the locations of all of our good delimiters!
    // yay!!!
    
    // set up into different strings for the monomials!
    
    // set the array of the monomials to be the number of good delimiters + 1
    if(DEBUGGING){
      std::cout << "The locations of the 'good' delimiters are : ";
    
      for (int i = 0; i < good_delims.size(); ++i){
	std::cout << good_delims[i] << " ";
      }
      std::cout << std::endl;
    }

    if (Monomials){
      if(DEBUGGING){
	std::cout << "delete[] Monomials in Set" << std::endl;
      }
      delete[] Monomials;
      Monomials = NULL;
      size = 0;
    }
    if(DEBUGGING){ 
      std::cout << "new Monomial[good_delims.size() + 1]" << std::endl;
    }
    // Monomials = new Monomial[good_delims.size() + 1];
    // size = good_delims.size();
    
    // create the strings to parse
    vector<string> ToParse;
    if (good_delims.size()){
      // we have at least 1 good delimiter -- meaning 2 monomials at least
      std::string current = s.substr(0, good_delims[0]);
      ToParse.push_back(current);
      // now create the rest of the substrings
      for (int i = 1; i < good_delims.size(); ++i){
	current = 
	  s.substr(good_delims[i-1], good_delims[i] - good_delims[i-1]);
	ToParse.push_back(current);
      }
      // get the last string
      ToParse.push_back(s.substr(good_delims[good_delims.size()-1]));
      for (int i = 0; i < ToParse.size(); ++i){
	std::cout << "String " << i << " = "
		  << ToParse[i]
		  << std::endl;
      }
    }
    else{
      // we have no delimiters, so the only thing to parse is the entire
      // string
      ToParse.push_back(s);
    }

    // OK, now we go ahead and create our Monomial array of
    // the appropriate size -- namely
    // ToParse.size()
    
#ifdef debugmem
      std::cout << "\n******\n\nallocating Monomials\n\n******\n";
#endif
      if (this->Monomials != NULL){
          delete[] this->Monomials;
          this->Monomials = NULL;
      }
    Monomials = new Monomial[ToParse.size()];
#ifdef debugmem
      std::cout << "\n******\n\nallocating LC\n\n******\n";
#endif
      
      if (this->LC != NULL){
          delete[] this->LC;
          this->LC = NULL;
      }
    LC = new Rational[ToParse.size()];
    size = ToParse.size();
    
    for (int i = 0; i < size; ++i){
      Monomial M;
      std::string current = ToParse[i];
      // strip off the LC
      std::string LCstr = "";
      int negc = 0;
      // count the number of - up to the integer
      int cindex = 0;
      while (!isdigit(current[cindex])){
	if (current[cindex] == '-'){
	  ++negc;
	}
	++cindex;
      }
      LCstr.append(negc % 2 ? "-": "");
      while (isdigit(current[cindex]) || current[cindex] == '/'){
	LCstr.append(current.substr(cindex,1));
	++cindex;
      }
      current = current.substr(cindex);
      M.Set(current);
      Monomials[i] = M;
      Rational currentLC;
      stringstream l;
      l << LCstr;
      l >> currentLC;
      LC[i] = currentLC;
    }

    /*
    if (good_delims.size()){
      // we have good delimiters in here
      
      // let's make the first string
      std::string current = s.substr(0, good_delims[0]); 
      // we want the string to go from 0 to the position
      // before the delimiter
      // wahoo

      

      // I want to dynamically allocate a monomial, otherwise when
      // we go out of scope, the destructor will be called on it
      // and voila, bad stuff happens ... so, nothing ...
	Monomial *M = new Monomial;
	M->Set(current);
	Monomials[0] = *M;
      
      

	Monomial M;
	M.Set(current);
	Monomials[0] = M;
      
    }
    else{
      // there was no good delimiter
      // so the polynomial is just a single monomial term
    
      

        
      Monomial M;
      M.Set(s);
      Monomials[0] = M;
      
        


      // I want to dynamically allocate a monomial, otherwise when
      // we go out of scope, the destructor will be called on it
      // and voila, bad stuff happens ... so, nothing ...
   
      Monomial* M = new Monomial;
      M->Set(s);
      Monomials[0] = *M;
      
    }
    
    // set the monomials up until the last one
    for (int i = 1; i < good_delims.size(); ++i){
      std::string current = s.substr(good_delims[i-1], good_delims[i] - 1 
				     - good_delims[i-1] + 1);
      
      
      Monomial M;
      M.Set(current);
      Monomials[i] = M;
      
    

      
      // I want to dynamically allocate a monomial, otherwise when
      // we go out of scope, the destructor will be called on it
      // and voila, bad stuff happens ... so, nothing ...
      Monomial* M = new Monomial;
      M->Set(current);
      Monomials[i] = *M;
 
      
    }
    
    // set the last one
    
    
      Monomial M;
      M.Set(s.substr(good_delims[good_delims.size()-1]));
      Monomials[good_delims.size() - 1] = M;
    
    


      
      // I want to dynamically allocate a monomial, otherwise when
      // we go out of scope, the destructor will be called on it
      // and voila, bad stuff happens ... so, nothing ...

    Monomial* M = new Monomial;
    M->Set(s.substr(good_delims[good_delims.size()-1]));
    Monomials[good_delims.size()-1] = *M;
    */
    
    if(DEBUGGING){    
      std::cout << "The Polynomial string was : " << s << std::endl << std::endl;
      std::cout << "The Polynomial was set to : ";
      
      for (int i = 0; i < size; ++i){
	std::cout << LC[i];
	std::cout << Monomials[i];
	if (i != size - 1){
	  std::cout << "+";
	}
      }
      std::cout << std::endl;
      std::cout << "Leaving Polynomial::Set(std::string s)" << std::endl;
    }
  }
  
  /*  Polynomial(std::string s){
    Set(s);
    }
  */
  
  std::string toString(){
    stringstream s;
    Insert(s);
    return s.str();
  }

  void Extract(istream &sin) {
    // put whatever is on the stream into the string
    std::string the_string;
    sin >> the_string;
    
    Set(the_string);
    return;
  }

  void Insert(ostream &sout){

    for (int i = 0; i < size; ++i){
      if (LC[i] != 0){
	sout << (LC[i] > 0 && i!=0 ?"+" :"") << LC[i];
	// if (i != size -1){
	// std::cout << "In insert LC[i] = " << LC[i] << "\n";
	if(!Monomials[i].IsConstant()){
	sout << "*";
	}
	sout << Monomials[i];
	/*	if (i != size - 1){
	  if (LC[i+1] > 0){
	    sout << "+";
	  }
	*/
	  
	//	}
      }
    }
    return;
  }


  Polynomial& operator=(const Polynomial& p) {
    // std::cout << "Entering assignment operator" << std::endl;
    if (this != &p) {  // make sure not same object  
      //  std::cout << "Not the same object ... " << std::endl;
      if (this->Monomials != NULL){
	//	std::cout << "delete[] Monomials in Poly assignment op"
	//	<< std::endl;
	delete[] this->Monomials;
      }
      if (this->LC != NULL){
	delete[] this->LC;
      }
      this->size = p.size;
      this->Monomials = new Monomial[size];
      this->LC = new Rational[size];
      for (int i = 0; i < size; ++i){
	this->Monomials[i] = p.Monomials[i];
	this->LC[i] = p.LC[i];
      }
    }
    //    std::cout << "Leaving assignment operator" << std::endl;
    return *this;    // Return ref for multiple assignment
  } 
    
    
    
    bool isBalanced(std::string s){
      
    
      // return true ... for now
      
      return true;
    }
  
  
  
};

ostream & operator << (ostream & sout, Polynomial & p){

  p.Insert(sout);
  return sout;
}
istream & operator >> (istream & sin, Polynomial & p){
  p.Extract(sin);
  return sin;
}



#endif
