#ifndef VARIABLE_H_
#define VARIABLE_H_

#ifndef DEBUGGING
#define DEBUGGING 0
#endif

// the structs to be used in the tree class
#include "rational.h"
#include <ctype.h>
#include <string>
#include <iostream>
// #include <stringstream>
#include <istream>
#include <ostream>

struct Variable {
public :
  int exp; // keep track of the exponent
  int var_no; // variable number
  char var_name; // variable name
  // Default Constructor
  
  Variable(char name = 127, int var = 0){ //, int e = 0){//, int e = 0){
    
    if (DEBUGGING){
      //  std::cout << "Entering Variable()" << std::endl;
    }
    var_name = name;
    var_no = var;
    //  exp = e;
    
    if (DEBUGGING){
      //  std::cout << "Leaving Variable()" << std::endl;
    }
  }
  ~Variable(){
    // do nothing
    
    if (DEBUGGING){
      //    std::cout << "Entering ~Variable()" << std::endl;
      // std::cout << "Leaving ~Variable()" << std::endl;
    }
  }
  // Copy Constructor
  Variable(const Variable & v){
    //  std::cout << "Entering copy constructor\n";
    
    this->var_name = v.var_name;
    this->var_no = v.var_no;
    // this->exp = v.exp; 
    //  std::cout << "Leaving copy constructor\n";
  }
  // Constructor with passing a string
  Variable(std::string s){
    
    if(DEBUGGING){
      std::cout << "Entering Variable(std::string s)" << std::endl;
    }
    Set(s);
    if(DEBUGGING){ 
      std::cout << "Leaving Variable(std::string s)" << std::endl;
    }
  }
  void Set(std::string s){
   
    if(DEBUGGING){
      std::cout << "Entering Variable::Set(std::string s)" << std::endl;    
    }
    // remove all the ' '
    
    s = removeChar(s,' ');
    if(DEBUGGING){        
      std::cout << "The variable string is : " << s << std::endl;
    }
    //      std::cout << "The variable string is : " << s << std::endl;
    // pass a string to set as the variable
    // get the char for the var_name
    char c = '\0';
    int firstalpha = 0;
    for (int i = 0; i < s.size() && !c; ++i){
      if (isalpha(s[i])){ // set to first alpha character
	c = s[i];
	var_name = c;
	firstalpha = i;
      }
    }
    //    std::cout << "firstalpha = " << firstalpha << "\n";
    if (c == '\0'){ // c is still null, so no variable name
      // set to 'x', 
      var_name = 'x';     
    }
    // find the variable number
    // locate the _
    //set  var_no to 0 ... just in case
    var_no = 0;
    // exp = 0;
    int und_l = s.find(firstalpha+1,'_');   
    if (und_l != string::npos){
      //      std::cout << "found a '_' ! \n";
      // we found it!
      // strip off the { }, if they exist
      if (s[und_l + 1] == '{'){
	// find the location of the rb
	int rb_l = s.find('}', und_l + 2);
	// has to be somewhere ... expression is balanced
	// so no need to test if it didn't find it
 	std::string var_no_str = 
	  s.substr(und_l + 2, (rb_l - 1) - (und_l + 2) + 1);
	if (var_no_str.size() == 0){
	  // nothing in the {} braces // set to 0
	  var_no = 0;
	} // re: var_no_str.size() == 0
	else{
	  // put the string onto a stream
	  stringstream in;
	  in << var_no_str;
	  in >> var_no;
	} // re: var_no_str.size() != 0
      } // re: s[und_l+1] == {
      else{ // there was no {
	std::string var_no_str = "";
	int i = firstalpha+1;
	while (isdigit(s[i])){
	 
	  var_no_str.append(s.substr(i,1));
	  ++i;
	  // not checking for anything like spaces after the underscore
	}
	if (var_no_str.size() == 0){
	  // nothing after the underscore
	  var_no = 0;
	}
	else{
	  // put the string onto a stream
	  stringstream in;
	  in << var_no_str;
	  in >> var_no;
	}
      }
    }
    else{
      // we didn't find it :( ... that's ok... just check if the following
      // character is a number 
      //      var_no = 0;
      
      std::string var_no_str = "";
      int i = firstalpha+1;
      // note: if i = s.size(), then s[i] = '\0', so ok
      while (isdigit(s[i])){
	var_no_str.append(s.substr(i,1));
	++i;
      } // re: end while
      if (var_no_str.size() == 0){
	// nothing after the first alpha character
	var_no = 0;
      } // re: var_no_str.size() == 0
      else{
	// put the string onto a stream                                         
	stringstream in;
	in << var_no_str;
	in >> var_no;
	
      } // re: var_no_str.size() != 0
      
    }   // re: end not finding a '_'
    if(DEBUGGING){
      std::cout << "The variable string was : " << s << std::endl << std::endl;
      std::cout << "The variable was set to : " << toString() << std::endl;     
      std::cout << "Leaving Variable::Set(std::string s)" << std::endl;
    }    
  }
  char GetName() const { return var_name;}
  void SetName(char c){ var_name = c;}
  int GetVariable() const{
    return var_no;
  }
  void SetVariable(int var){
  var_no = var;
  }
  /*
  void SetExponent(int e){
  exp = e;
  }
  int GetExponent() const { return exp; }
  */
  // bool IsConstant(){ return !exp;}

  void Extract(istream &sin) {
    // put whatever is on the stream into the string
    std::string the_string;
    sin >> the_string;
    
    Set(the_string);
    return;
  }

  void Insert(ostream &sout){
    sout << var_name  << var_no;
    return;
  }
  
  std::string toString(){
    
    stringstream s;
    Insert(s);
    return s.str();
  }

  
  std::string removeChar(std::string s, char c){
    std::string r = "";
    for (int i = 0; i < s.length(); ++i)
      {
	if (s[(i)] != c){
	  r += s[(i)];
	}
      }
    return r;
  }
  
  Variable& operator=(const Variable& v) {
    //  std::cout << "Entering assignment operator\n";
    if (this != &v) {  // make sure not same object      
      //    this->exp = v.exp;
      this->var_name = v.var_name;
      this->var_no = v.var_no;
    }
    //  std::cout << "Leaving assignment operator\n";
    return *this;    // Return ref for multiple assignment
  }  
    
  };

 ostream & operator << (ostream & sout, Variable & v){
  
  v.Insert(sout);
  return sout;
}
istream & operator >> (istream & sin, Variable & v){
  v.Extract(sin);
  return sin;
}
// only test to see if variable has same exponent, variable number, and variable name

bool operator == (const Variable & r, const Variable & s){
  // if it's the const value, exponent is 0, so it doesn't matter
  // what the var_name or number is
  // if (r.GetExponent() == 0 && s.GetExponent() == 0){
  // return true;
  // }
  // else{
  if (//r.GetExponent() == s.GetExponent() 
      r.GetVariable() == s.GetVariable()
      && r.GetName() == s.GetName())
    return true;
  else
    return false;
}


bool operator < (const Variable & r, const Variable & s){
  //  std::cout << "Entering < operator for Variable" << std::endl;
 
  // give order of preference to lower characters
  // give order of preference to lower numbers if same character
  if (r.GetName() < s.GetName()){
    return true;
  }
  else if (r.GetName() > s.GetName()){
    return false;
  }
  else{ // same variable name
    
    if (r.GetVariable() < s.GetVariable()){ // r.name_no < s.name_no
      //  std::cout << "Leaving < operator for Variable" << std::endl;
      return true;
    }
    else{ // r.name_no >= s.name_no
      return false;
    }
  }
}

bool operator != (const Variable & r, const Variable & s){
  return !(r == s);
}

bool operator <= (const Variable & r, const Variable & s){
  // std::cout << "Entering <= Variable" << std::endl;

  // std::cout << "Leaving <= Variable" << std::endl;
  return (r < s | (r == s));
}

bool operator > (const Variable & r, const Variable & s){
  return !(r <= s);
}

bool operator >= (const Variable & r, const Variable & s){
  return !(r < s);
}

std::string removeChar(std::string s, char c){

  std::string r = "";
  
  for (int i = 0; i < s.length(); ++i)
    {
      if (s[(i)] != c){
	r += s[(i)];
      }
    }
  return r;
}


#endif
