#ifndef FUNCTIONS_H_
#define FUNCTIONS_H_

template<class T>
inline T abs(T d1){
  T d2 = d1;
  if (d2 < 0){
    d2 = -1*d2;
  }
  return d2;
}

/*inline Rational abs(Rational r1){      
  Rational R2 = r1;
  if (R2 < 0){
    R2 = -1*R2;
  }
  return R2;
}
*/

template<class T>
inline void SwapColumns(T** A, int rows, int col1, int col2){
  std::cout << "Swapping Columns!\n";
    for (int i = 0; i < rows;++i){
        T tmp = A[i][col1];
        A[i][col1]=A[i][col2];
        A[i][col2]=A[i][col1];
    }
}


template<class T>
inline void Swap(T& v1,T& v2)
{
  //  std::cout << "Entering swap" << std::endl;
#ifdef debugmem
    std::cout << "\n******\n\nallocating T\n\n******\n";
#endif
  T* temp = new T;
  // std::cout << "Before swap takes place : "
  //    << std::endl << v1 << " and " << v2 << std::endl;
  *temp = v2;
  v2=v1;
  v1=*temp;
  //  std::cout << "After swap takes plae and before delete temp : "
  //    << std::endl
  //    << v1 << " and " << v2 << std::endl;
  delete temp;
  // std::cout << "Leaving swap" << std::endl;
}


template<class T>
void QuickSort(T A[], int size, int a, int b){
  //  std::cout << "size = " << size << "   a = " << a << "   b = " << b
  //    << std::endl;
  int rtidx=0,ltidx=0,k=a,l=0;
  T pivot;  
  

  T* leftarr = new T[size];
  T* rtarr = new T[size]; 


  pivot=A[a];
  if(a==b)return;
  while(k<b)
    {
      ++k;
      if(A[k]<A[a])	
	{
	  leftarr[ltidx]=A[k];
	  ltidx++;
	}
      else
	{
	  rtarr[rtidx]=A[k];
	  rtidx++;
	}
    }
  k=a;
  for(l=0;l<ltidx;++l)A[k++]=leftarr[l];
  A[k++]=pivot;
  for(l=0;l<rtidx;++l)A[k++]=rtarr[l];
  
  delete[] leftarr;
  delete[] rtarr;

  if(ltidx>0)QuickSort(A, size, a,a+ltidx-1);
  
  if(rtidx>0)QuickSort(A, size, b-rtidx+1,b);  
}


// Quicksort with two arrays, first array is to be sorted
// second array is keyed in with first array

template<class T, class T2> 
  void QuickSort(T A[], int size, int a, int b, T2 B[]){
  //  std::cout << "size = " << size << "   a = " << a << "   b = " << b
  //    << std::endl;
  int rtidx=0,ltidx=0,k=a,l=0;
  T pivot;
  T2 pivot2;
  T* leftarr = new T[size];
  T* rtarr = new T[size];
  T2* leftarr2 = new T2[size];
  T2* rtarr2 = new T2[size];
 

  pivot=A[a];
  pivot2=B[a];
  if(a==b)return;
  while(k<b)
    {
      ++k;
      if(A[k]<A[a])	
	{
	  leftarr[ltidx]=A[k];
	  leftarr2[ltidx]= B[k];
	  ltidx++;
	}
      else
	{
	  rtarr[rtidx]=A[k];
	  rtarr2[rtidx] = B[k];
	  rtidx++;
	}
    }
  k=a;
  for(l=0;l<ltidx;++l){
    A[k]=leftarr[l];
    B[k]=leftarr2[l];
    k++;
  }
  A[k]=pivot;
  B[k]=pivot2;
  k++;
  for(l=0;l<rtidx;++l){
    A[k]=rtarr[l];
    B[k]=rtarr2[l];
    k++;
  }
  
  delete[] leftarr;
  delete[] leftarr2;
  delete[] rtarr;
  delete[] rtarr2;

  if(ltidx>0)QuickSort(A, size, a,a+ltidx-1, B);  
  if(rtidx>0)QuickSort(A, size, b-rtidx+1,b, B);  
}



template<class T>
void TestComparisons(T a[], int size){ 
  for (int i = 0; i < size; ++i){
    for (int j = i; j < size; ++j){
      std::cout << "Testing : "
		<< a[i] << " == " << a[j]
		<< " - " 
		<< (a[i] == a[j] ? "true" : "false")
		<< std::endl
		<< "Testing : "
		<< a[i] << " < " << a[j]
		<< " - "
		<< (a[i] < a[j] ? "true" : "false")
		<< std::endl
		<< "Testing : "
		<< a[i] << " <= " << a[j]
		<< " - " 
		<< (a[i] <= a[j] ? "true" : "false")
		<< std::endl
		<< "Testing : "
		<< a[i] << " > " << a[j]
		<< " - "
		<< (a[i] > a[j] ? "true" : "false")
		<< std::endl
		<< "Testing : "
		<< a[i] << " >= " << a[j]
		<< " - " 
		<< (a[i] >= a[j] ? "true" : "false")
		<< std::endl
		<< "Testing : "
		<< a[i] << " != " << a[j]
		<< " - "
		<< (a[i] != a[j] ? "true" : "false")
		<< std::endl; 
    } 
  }  
}

template<class T>
void printArray(T a[], int size){
  for (int i = 0; i < size; ++i){
    std::cout << a[i] << " ";
  }
  
}





/** Given a sorted array with duplicates, return a sorted array with no duplicates */
 
template<class T>
T* RemoveDuplicates(T a[], int & size){
  
  int size2 = 1;
#ifdef debugmem
    std::cout << "\n******\n\nallocating t1\n\n******\n";
#endif
  T* t1 = new T[size];
  t1[0] = a[0];
  for (int i = 1; i < size;++i){
    if (t1[size2-1] != a[i]){
      // put it in the array
      t1[size2] = a[i];
      ++size2;
    }
  }
  T* t2 =  new T[size2];
  for (int i = 0; i < size2; ++i){
    t2[i] = t1[i];
  }
  delete[] t1;
  t1 = NULL;
  size = size2;
  return t2;
}


template<class T>
int binarySearch(T sortedArray[], int first, int last, T key) {
   // function:
   //   Searches sortedArray[first]..sortedArray[last] for key.  
   // returns: index of the matching element if it finds key, 
   //         otherwise  -(index where it could be inserted)-1.
   // parameters:
   //   sortedArray in  array of sorted (ascending) values.
   //   first, last in  lower and upper subscript bounds
   //   key         in  value to search for.
   // returns:
   //   index of key, or -insertion_position -1 if key is not 
   //                 in the array. This value can easily be
   //                 transformed into the position to insert it.
  
  while (first <= last) {
    int mid = (first + last) / 2;  // compute mid point.
    if (key > sortedArray[mid]) 
      first = mid + 1;  // repeat search in top half.
    else if (key < sortedArray[mid]) 
      last = mid - 1; // repeat search in bottom half.
    else
      return mid;     // found it. return position /////
  }
  return -(first + 1);    // failed to find key
}


/*
template<class T>
int Find(T SortedArray[], T t, int beginning, int end){
  int s = end - beginning + 1;
  if (s == 1){
    if (v <= Variables[beginning]){ // give ordering
      // preference to
      // current variable
      return beginning;
    }
    else
      return beginning+1;
  }
  // go to recursive case
  int middle = (beginning + end)/2;
  if (Variables[middle] < v){
    return Find(v, beginning, middle-1);
  }
  else
    return Find(v, middle, end);
}
*/

template<class T>
void GaussianEliminationT(T** A, int rows, int columns){
  int i = 0;
  int j = 0;
  while (i < rows && j < columns) {
    //  Find pivot in column j, starting in row i:                              
    int maxi = i;

    for (int k = i+1; k < rows; ++k){
      if (abs(A[k][j]) > abs(A[maxi][j])){
        maxi = k;
      }
    }

    if (A[maxi][j] != 0){

      if (maxi != i){
        // swap the two rows                                                    
	std::cout << "Swapping Rows!\n";
#ifdef debugmem
          std::cout << "\n******\n\nallocating temp\n\n******\n";
#endif
	T* temp = new T[columns];
          
        temp = A[i];
        A[i] = A[maxi];
        A[maxi] = temp;
	temp = NULL;


      }

      //divide each entry in row i by A[i][i])                                  
      //Now A[i][i] will have the value 1.                                      

      T r2 = A[i][j];
      for (int c = 0; c < columns; ++c){

        T r1 = A[i][c];
        T ToSet;
        ToSet = r1/r2;
        A[i][c] = ToSet;
      }
      for (int u = i+1; u < rows; ++u){
        // subtract A[u][j] * row i from row u                                                                              
        // Now A[u,j] will be 0, since A[u,j] - A[i,j] * A[u,j] = A[u,j] - 1 * A[u,j] = 0.                                  

        T m = A[u][j];
        if (m !=0){ // skip calculations if 0                                                                               
          for (int c = 0; c < columns; ++c){
            A[u][c] = A[u][c] - m*A[i][c];
          }
        }
      }
      ++i;
    }
    ++j;
  }

  /* Do the back substitution */

  for (i = rows - 2; i >= 0; --i){
    // find the column that is the first                                                                                    
    // one in the i+1 row that is nonzero                                                                                   
    int col = 0;
    bool found = false;
    for (; col < columns && !found; ++col){

      if (A[i+1][col] != 0){
        found = true;

      }
    }
    if (col - 1 < columns){
      for (int k = 0; k <= i; ++k){
        T Multiple = A[k][col-1];
        if (Multiple != 0){
          for (int j = col-1; j < columns; ++j){
            A[k][j] = A[k][j] - Multiple*A[i+1][j];
          }
        }
      }
    }
  }
}


void GaussianElimination2(Rational** A, int rows, int columns){

  int i = 0;
  int j = 0;
  while (i < rows && j < columns) {
    //  Find pivot in column j, starting in row i:
    int maxi = i;

    for (int k = i+1; k < rows; ++k){

      
      if (abs(A[k][j]) > abs(A[maxi][j])){

	maxi = k;

	
      }
    } 
    
    // bool pivotfound = false;
    
    //    while(!pivotfound){
    
    if (A[maxi][j] != 0){
      
      if (maxi != i){
	// swap the two rows
		std::cout << "Swapping row " << i << " with row "  
			  << maxi << std::endl;
#ifdef debugmem
          std::cout << "\n******\n\nallocating temp\n\n******\n";
#endif
	Rational* temp = new Rational[columns];
	temp = A[i];
	A[i] = A[maxi];
	A[maxi] = temp;
	temp = NULL;
	
	// output the the new matrix
	// after the swap


      }
      
      
      //divide each entry in row i by A[i][i])
      //Now A[i][i] will have the value 1.
      
      Rational r2 = A[i][j];
      for (int c = 0; c < columns; ++c){
	
	Rational r1 = A[i][c];
	Rational ToSet;
	ToSet = r1/r2;
	A[i][c] = ToSet;
      }
           
      
      for (int u = i+1; u < rows; ++u){ 
	// subtract A[u][j] * row i from row u
	// Now A[u,j] will be 0, since A[u,j] - A[i,j] * A[u,j] = A[u,j] - 1 * A[u,j] = 0.
	
	Rational m = A[u][j];
	if (m !=0){ // skip calculations if 0
	  for (int c = 0; c < columns; ++c){
	    A[u][c] = A[u][c] - m*A[i][c]; 
	  }  	  
	}
      }
      ++i;
    }
    ++j;
  }


  
  /* Do the back substitution */
  
  for (i = rows - 2; i >= 0; --i){
    // find the column that is the first
    // one in the i+1 row that is nonzero
    int col = 0;
    bool found = false;
    for (; col < columns && !found; ++col){

      if (A[i+1][col] != 0){
	found = true;

      }
    }

   
    if (col - 1 < columns){
      
      for (int k = 0; k <= i; ++k){
	Rational Multiple = A[k][col-1];

	if (Multiple != 0){
	  for (int j = col-1; j < columns; ++j){
	    A[k][j] = A[k][j] - Multiple*A[i+1][j];
	  }
	}		
      }
    }
  }
} 
// n = rows



void GaussianElimination(Rational** A, int rows, int columns){

  int i = 0;
  int j = 0;
  while (i < rows && j < columns) {
    //  Find pivot in column j, starting in row i:
    int maxi = i;
    // std::cout << "i = " << i << "\nj = " << j << "\n";
    for (int k = i+1; k < rows; ++k){
      /*   std:cout << "abs(A[" << k << "][" << j << "]) = "
	     << abs(A[k][j])
	     << ", abs(A[" << maxi << "][" << j << "]) = "
	     << abs(A[maxi][j])
	     << std::endl;
      */
      if (abs(A[k][j]) > abs(A[maxi][j])){
	//	std::cout << abs(A[k][j]) << ">" << abs(A[maxi][j]) << "\n\n";
	maxi = k;
	//	std::cout << "Max row for column " << j 
	//	  << " is " << maxi
	//  << std::endl;
	
      }
    } 
    
    // bool pivotfound = false;
    
    //    while(!pivotfound){
    
    if (A[maxi][j] != 0){
      
      if (maxi != i){
	// swap the two rows
		std::cout << "Swapping row " << i << " with row "  
			  << maxi << std::endl;
#ifdef debugmem
          std::cout << "\n******\n\nallocating temp\n\n******\n";
#endif
	Rational* temp = new Rational[columns];
	temp = A[i];
	A[i] = A[maxi];
	A[maxi] = temp;
	temp = NULL;
	
	// output the the new matrix
	// after the swap
	/*	std::cout << std::endl;
		for (int z = 0; z < rows; ++z){
		  printArray(A[z], columns);
		  std::cout << std::endl;
		}
	*/
		//  pivotfound = true;
      }
      
      
      //divide each entry in row i by A[i][i])
      //Now A[i][i] will have the value 1.
      
      Rational r2 = A[i][j];
      for (int c = 0; c < columns; ++c){
	
	Rational r1 = A[i][c];
	Rational ToSet;
	ToSet = r1/r2;
	A[i][c] = ToSet;
      }
      
      /* std::cout << std::endl;
      for (int z = 0; z < rows; ++z){
	printArray(A[z], columns);
	std::cout << std::endl;
      }
      
      std::cout << std::endl;
      
      */
      for (int u = i+1; u < rows; ++u){ 
	// subtract A[u][j] * row i from row u
	// Now A[u,j] will be 0, since A[u,j] - A[i,j] * A[u,j] = A[u,j] - 1 * A[u,j] = 0.
	
	Rational m = A[u][j];
	if (m !=0){ // skip calculations if 0
	  for (int c = 0; c < columns; ++c){
	    A[u][c] = A[u][c] - m*A[i][c]; 
	  }
	  
	  //  std::cout << std::endl;
	  /* for (int z = 0; z < rows; ++z){
	    printArray(A[z], columns);
	    std::cout << std::endl;
	  }
	  */
	}
      }
      ++i;
    }

    ++j;
  }
  
  //  std::cout << "Before the back substitution : " << std::endl;
  
  //  std::cout << std::endl;
  /* for (int m = 0; m < rows; ++m){
    printArray(A[m], columns);
    std::cout << std::endl;
  }
  std::cout << std::endl;
  */
  /* Do the back substitution */
  
  for (i = rows - 2; i >= 0; --i){
    // find the column that is the first
    // one in the i+1 row that is nonzero
    int col = 0;
    bool found = false;
    for (; col < columns && !found; ++col){
      //  std::cout << "testing row " << i + 2 << " and column " << col + 1 << std::endl;
      if (A[i+1][col] != 0){
	found = true;
	//	std::cout << "found!" << std::endl;
      }
    }
    //    std::cout << "col - 1 = " << col - 1 << std::endl;
   
    if (col - 1 < columns){
      
      for (int k = 0; k <= i; ++k){
	Rational Multiple = A[k][col-1];
	//	std::cout << "Multiple is : " << Multiple << std::endl;
	if (Multiple != 0){
	  for (int j = col-1; j < columns; ++j){
	    /*  std::cout << "Setting A[" << k << "][" << j << "] = A[" << k << "]["
		      << j << "] - " << Multiple 
		      << "*A[" << i+1 << "][" << j << "]" << std::endl
		      << "OR \n\n"
		      << "A[" << k << "][" << j << "] = "
		      << A[k][j] << "-" << Multiple << "*" << A[i+1][j]
	          << std::endl;
	    */
	    A[k][j] = A[k][j] - Multiple*A[i+1][j];
	  }
	}
     
	//	std::cout << std::endl;
	/*	for (int m = 0; m < rows; ++m){
	  printArray(A[m], columns);
	  std::cout << std::endl;
	}
		std::cout << std::endl;
	*/
      }
    }
  }
} 
// n = rows


#endif
