#ifndef SIGNPATTERN_H_
#define SIGNPATTERN_H_

#include <iostream>
#include <cmath>
#include <vector>



struct SignPattern{


  std::vector<int> IntVec;
  std::vector<int> thesigns;
  
    SignPattern(){ // default constructor
      IntVec = std::vector<int>();  
      thesigns = std::vector<int>();
	

    }
  
    SignPattern(SignPattern & S1){ // deep copy constructor
      
      //      std::cout << "Entering    SignPattern(SignPattern & S1)\n";

      this->thesigns=std::vector<int>(S1.thesigns.size());
      this->IntVec=std::vector<int>(S1.IntVec.size());
      
      // fail safe, shouldn't EVER occur . . . 
      
      if (this->thesigns.size() != this->IntVec.size()){
	std::cerr << "Something seriously wrong.  This should never appear.\n"
		  << "Located in struct:Signpatter::Signpattern(SignPattern & S1)\n";
	std::cerr << "this->thesigns.size() != this->IntVec.size()) !!";
	std::cerr << "this->thesigns.size() = " << this->thesigns.size()
		  << "\nthis->IntVec.size() = " << this->IntVec.size() << "\n";
	// std::cerr << "Leaving SignPattern(SignPattern & S1)\n";

	return;
      }
      
      for (int i = 0; i < S1.thesigns.size();++i){
	this->thesigns[i] = S1.thesigns[i];
	this->IntVec[i] = S1.IntVec[i];
	
        }
      //      std::cout << "Leaving SignPattern(SignPattern & S1)\n";
    }
    SignPattern(const SignPattern & S1){ // deep copy constructor
        this->thesigns=std::vector<int>();
	this->IntVec=std::vector<int>();
        for (int i = 0; i < S1.thesigns.size();++i){
            this->thesigns.push_back(S1.thesigns[i]);
            this->IntVec.push_back(S1.IntVec[i]);

        }

    }
  
  /** THE CONSTRUCTORS -- And only DEEP constructors */
  
  SignPattern(std::vector<int> thevec){
    
    this->thesigns = std::vector<int>(thevec.size());
    this->IntVec   = std::vector<int>(thevec.size()); 
    for (int i = 0; i < thevec.size();++i){
      this->thesigns[i] = thevec[i] % 2;
      this->IntVec[i] = thevec[i];
    }
      
  }


  
  ~SignPattern(){ // destructor
    
  }
  
  SignPattern& operator=(const SignPattern& S) {
    if (this != &S) {  // make sure not same object
      this->thesigns=std::vector<int>(S.thesigns.size());
      this->IntVec=std::vector<int>(S.IntVec.size());
      for (int i = 0; i < this->thesigns.size();++i){
	this->IntVec[i] = S.IntVec[i];
	this->thesigns[i]=S.thesigns[i];
      }
      
    }
    return *this;
  }

};  // end struct




int Identifier(SignPattern sp1){
  
  //  std::vector<int> tmp;
  int id = 0;
  for (int i = 0; i < sp1.thesigns.size();++i){
    if (sp1.thesigns[i] < 0){
      //  tmp.push_back(2);
      
      id += int(
		pow(
		    double(3),
		    double(sp1.thesigns.size() - i))
		*2);
    }
    if (sp1.thesigns[i] == 0){
      //      tmp.push_back(0);
      
    }
    else{
      //      tmp.push_back(1);
      id += int(
		pow(
		    double(3),
		    double(sp1.thesigns.size() - i)));
    }
  }
  
  return id;
}

double Norm(SignPattern S1){
  
  double norm = 0.0;
    for (int i = 0; i < S1.IntVec.size();++i){
      norm += pow(double(S1.IntVec[i]),double(2));
    }
    return pow(norm,.5);
}
/*
  double Norm(SignPattern & S1){
  
  double norm = 0.0;
  for (int i = 0; i < S1.thesigns.size();++i){
  norm += pow(double(S1.thesigns[i]),double(2));
  }
  return pow(norm,.5);
  }
  
  double Norm(const SignPattern & S1){
  
  double norm = 0.0;
  for (int i = 0; i < S1.thesigns.size();++i){
  norm += pow(double(S1.thesigns[i]),double(2));
  }
  return pow(norm,.5);
  }
  
*/

int Pos(SignPattern S1){
  int pos = 0;
  for (int i = 0; i < S1.IntVec.size(); ++i){
    if (S1.IntVec[i] > 0)
      ++pos;
  }    
  return pos;
}



int Neg(SignPattern S1){
  int neg = 0;
  for (int i = 0; i < S1.IntVec.size(); ++i){
    if (S1.IntVec[i] < 0)
      ++neg;
  }    
  return neg;
}

int Zeroes(SignPattern S1){
    int zeroes = 0;
    for (int i = 0; i < S1.IntVec.size(); ++i){
      if (S1.IntVec[i] == 0){
	++zeroes;
      }
    }    
    return zeroes;
}


int MaxElement(SignPattern S){

  int curmax = 0;
  for (int i = 0; i < S.IntVec.size();++i){
    if (curmax < abs(S.IntVec[i])){
      curmax = abs(S.IntVec[i]);
    }
  }
  return curmax;
}


int MaxElementV(std::vector<int> v){

  int curmax = 0;
  for (int i = 0; i < v.size(); ++i){
    if (curmax < abs(v[i])){
      curmax = abs(v[i]);
    }
  }
  return curmax;

}



std::vector<int> MaxMultiplier(std::vector<SignPattern> OriginalBasis){

  std::vector<int> MyMaxes = std::vector<int>(OriginalBasis.size());

  return MyMaxes;
}

std::vector<int> NextMultiplier(std::vector<int> CurrentMultiplier, std::vector<int> MaxMultiplier){

  int currentlevel = CurrentMultiplier.size() - 1;
  std::vector<int> Next = std::vector<int>(CurrentMultiplier.size());

  // set next to be = to CurrentMultiplier

  for (int i = 0; i < CurrentMultiplier.size();++i){
    Next[i] = CurrentMultiplier[i];

  }

  bool done = false;

  while (currentlevel >= 0 && !done){

    if (CurrentMultiplier[currentlevel]+1 > MaxMultiplier[currentlevel]){

      // decrease the level and go back into loop to test if done
      // and reset everything past currentlevel to the - of the MaxMultiplier Values
      
      //      std::cout << "Decreasing level!\n";
      --currentlevel;
      
      
      for (int i = currentlevel+1; i < CurrentMultiplier.size(); ++i){
	Next[i] = -1*MaxMultiplier[i];
      }
      
      
    }
    else{


      Next[currentlevel] = CurrentMultiplier[currentlevel] + 1;

      done = true;
    }
    
  }

  // test if all 0's
  bool nonzero = false;
  for (int i = 0; i < Next.size() && !nonzero; ++i){
    if (Next[i] != 0){
      nonzero = true;
    }
  }
  std::vector<int> Next2;
  if (!nonzero){ // all zeros, increment to the next multiplier
    Next2 = NextMultiplier(Next, MaxMultiplier);
    Next = Next2;
  }
  

  if (!done) // we hit the end?! test if Next returns all 0s
    {
      
    
      std::vector<int> Next0(CurrentMultiplier.size());
      return Next0;
    }

  return Next;

}

std::vector<SignPattern>  GeneratePatterns(std::vector<SignPattern> OriginalSigns){
  
  std::vector<SignPattern> AllSigns = std::vector<SignPattern>(OriginalSigns.size());
  
  std::vector<int> MaxMultipliers = std::vector<int>(OriginalSigns.size());
  
  // create the max value in each dimension (positive or negative, but storing as positive)
  for (int i = 0; i < OriginalSigns.size();++i){
    MaxMultipliers[i] = MaxElement(OriginalSigns[i]);  
    
  }
  
  return AllSigns;
}



bool operator==(SignPattern & sp1, SignPattern & sp2){
  
  if (sp1.thesigns.size() != sp2.thesigns.size()){
    std::cerr << "Lengths of the null space vectors are not the same.\n"
    << "Cannot compare sign patterns!";
    return false;
  }
  else {
    
    // equality is if identifier is the same, i.e. if placement of +, -, and 0s is the same
    // when storing all the signpatterns in the CONTAINER (Currently HEAP)
    // at this point we test if pattern has not been found and put in its appropriate place
    // if pattern is already found, then at THIS point test for size of norm
    
    
    return ((Identifier(sp1) == Identifier(sp2)) && (Norm(sp1) == Norm(sp2)));    
  }
}


bool operator< (SignPattern & S1, SignPattern & S2){
    if (S1.IntVec.size() != S2.IntVec.size()){
        std::cerr << "Lengths of the null space vectors are not the same.\n"
                  << "Cannot compare sign patterns!\n";
	std::cerr << "S1.IntVec.size() = " << S1.IntVec.size() << "\n"
		  << "S2.IntVec.size() = " << S2.IntVec.size() << "\n"; 
        return false;
    }
    if (S1 == S2){ // exit out early if we are the same sign pattern
     
  
        return false;
    }
    // note:  no need to test for -S1 < S2
    int poss1 = Pos(S1);
    int poss2 = Pos(S2);
    int negs1 = Neg(S1);
    int negs2 = Neg(S2);
    int zeros1 = Zeroes(S1);
    int zeros2 = Zeroes(S2);

    double ns1 = Norm(S1);
    double ns2 = Norm(S2);
  
    int c1 = abs(poss1 - negs1);
    int c2 = abs(poss2 - negs2);
    

    //      std::cout << "c1 = " << c1 << "  c2 = " << c2 << "\n";
    
    if ((c1 + zeros1) < (c2 + zeros2)){
      // if the change in sign patterns
    

      return false;

    }
    else if (c1 == c2){
      if (ns1 >= ns2){
	return true;
      }
      else{
	return false;
      }
    }
    else{
      return true;

    }
}
bool operator> (SignPattern & sp1, SignPattern & sp2){
    return !(sp1 < sp2 && sp1 == sp2);
}


bool operator != (SignPattern & sp1, SignPattern & sp2){
  
  return !(sp1 == sp2);
  
}

bool operator <= (SignPattern & sp1, SignPattern & sp2){
  
  return (sp1 < sp2 && sp1 == sp2);
  
}

bool operator >= (SignPattern & sp1, SignPattern & sp2){
    return (sp1 > sp2 && sp1 == sp2);
}

SignPattern operator + (SignPattern & sp1, SignPattern & sp2){
  // make sure sizes of SignPattern
  
  if (sp1.thesigns.size() != sp2.thesigns.size()){
    return sp1;  // default, return left operand
  }
  SignPattern S;
  for (int i = 0; i < sp1.IntVec.size();++i){
    // S.thesigns.push_back(sp1.thesigns[i] + sp2.thesigns[i]);
    S.IntVec.push_back(sp1.IntVec[i] + sp2.IntVec[i]);
    S.thesigns.push_back((sp1.IntVec[i] + sp2.IntVec[i]) % 2);
  }
  return S;
}


SignPattern operator * (int & k, SignPattern & sp1){
  
  SignPattern Mine;
  //  std::cout << "Multiplier k = " << k << "\n";
  for (int i = 0; i < sp1.IntVec.size();++i){
    

    Mine.IntVec.push_back(k*sp1.IntVec[i]);        
    Mine.thesigns.push_back(k*sp1.thesigns[i] % 2);        
  }
  return Mine;
}

void BubbleSortByNorm(std::vector<SignPattern> & TheSigns){

  for (int i = 0; i < TheSigns.size();++i){
    for (int j = 0; j < i; ++j){
      if (Norm(TheSigns[i]) < Norm(TheSigns[j])){
        SignPattern Tmp = TheSigns[i];
        TheSigns[i] = TheSigns[j];
        TheSigns[j] = Tmp;
      }
    }
  }
}




std::vector<SignPattern> BestSigns(std::vector<SignPattern> TheSigns, int num){

  // screw sorting and comparison ... do a linear run through on 
  // number of sign changes and find the max -- keep those
  
  // std::vector<SignPattern> TheBest(num);
  std::vector<SignPattern> MostSCs;
  std::vector<SignPattern> NextMostSCs;

  // set the first num of SignPatterns in TheSigns into TheBest
  // don't worry about ordering here, will be done at the end
  
  // for (int i = 0; i < num;++i){
  //  TheBest[i] = TheSigns[i];
  // }

  int maxsc = 0;
  int nextmaxsc = 0;
  for (int i = 0; i < TheSigns.size(); ++i){
    int cursc = abs(Pos(TheSigns[i]) - Neg(TheSigns[i])) + Zeroes(TheSigns[i]);
    if (cursc > maxsc){
      nextmaxsc = maxsc;
      maxsc = cursc;
      NextMostSCs = MostSCs;
      MostSCs.resize(0);
      MostSCs.push_back(TheSigns[i]);
    }
    else if(cursc == maxsc){
      MostSCs.push_back(TheSigns[i]);
    }
    else if (cursc == nextmaxsc){
      NextMostSCs.push_back(TheSigns[i]);
    }
    else{
      // do nothing here
    }
  }

  // now, order these two buckets by Norm -- right ?
  // assumption is that if the sign pattern has the same norm,
  // one is the negative of the other (nearly always true, except for pathological examples!)
  // HERE --- CODE STUFF HERE --- !!
  // Go ahead and keep track of nonzero SignPatterns
  // and keep (al)l of them

  int nonzeroSPs = 0;

  BubbleSortByNorm(MostSCs);
  // don't sort if size of MostSCs > number of basis vectors needed
  // if (MostSCs.size() < num){
  BubbleSortByNorm(NextMostSCs);
  for (int j = 0; j < NextMostSCs.size();++j){
    MostSCs.push_back(NextMostSCs[j]);
  }
  // }
  return MostSCs;
}


void MyBubbleSort(std::vector<SignPattern> & TheSigns){

  
  for (int i = 0; i < TheSigns.size();++i){ // i is the current pass
    // bool swapped = false;
    for (int j = 0; j < i; ++j){
      if (TheSigns[i] > TheSigns[j]){
	// swapped = true;
	SignPattern Tmp = TheSigns[i];
	TheSigns[i] = TheSigns[j];
	TheSigns[j] = Tmp;
      }
      //      if (!swapped){
      //	break;
      // }
      
    }

  }

}


int gcd2(int m, int n) // function definition  
{ // block begin
  int absm = abs(m);
  int absn = abs(n);
  int r; // declaration of remainder  
  while (absn != 0) { // not equal  
    r = absm % absn; // modulus operator  
    absm = absn; // assignment  
    absn = r;  
  } // end while loop  
  return absm; // exit gcd with value absm  
}  

int gcd(std::vector<int> v){ // assume not passing a vector with only 1 nonzero
  
  // find the first 2 non-zero values of v
  
  bool foundfirst = false;
  bool foundsecond = false;
  int first = 0;
  int second = 1;
  for (int i = 0; i < v.size() && (!foundfirst || !foundsecond); ++i){
    if (v[i] != 0){
      if (!foundfirst){
	foundfirst = true;
	first = i;
      }
      else{
	foundsecond = true;
	second = i;
      }
    }
  }
  
  int curgcd = gcd2(v[first],v[second]);
  for (int i = second+1; i < v.size() && curgcd != 1; ++i){
    if (v[i] != 0){
      if( !(curgcd == 1 || v[i] == 1) ){
      curgcd = gcd2(curgcd, v[i]);
      }
      else{
	return 1;
      }
    }
  }
  return curgcd;
}


std::vector<SignPattern> RemoveRepresentative(std::vector<SignPattern> TheSigns, SignPattern Rep){
  std::vector<SignPattern> ToReturn;


  SignPattern SmallestRep = Rep;
  // 
  for (int i = 0; i < TheSigns.size(); ++i){
    if (Identifier(TheSigns[i]) == Identifier(SmallestRep)){
      // we have the same sign pattern, i.e. + + 0 - 0 and + + 0 - 0
      // set the smallest representative of the pattern accordingly
      if (Norm(SmallestRep) > Norm(TheSigns[i])){
	SmallestRep = TheSigns[i];
      }
    }
    else{
      ToReturn.push_back(TheSigns[i]);
    }
  }
  // push the smallest rep onto the vector
  ToReturn.push_back(SmallestRep);
  return ToReturn;
}

// remove all duplicates
/*
std::vector<SignPatter> RemoveAllDuplicates(std::vector<SignPattern> TheSigns){
  std::vector<SignPattern> ToReturn = TheSigns;

  for (int i = 0; i < 

}
*/
#endif
