//#include <stack>
#include <cctype>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <stdlib.h>
// #include <map>
#include <sstream>
#include "rational.h"
#include "Variable.h"
#include "Monomial.h"
#include "Polynomial.h"
#include "functions.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "structs.h"
#include "galefunctions.h"

using namespace std;

void WriteMapleOutput(std::string filename, int l, int m, int n, Polynomial* Parametrized, int** exp, int** mon_exp,Polynomial* All_Poly, Variable* All_Vars);
void writeAlphaCertifiedSolutionsRational(std::vector<std::vector<std::string> > TheRefinedStrings, std::string filename);

bool isAlphaCertified();
void WriteAlphaCertifiedSolutionsFloat(int display, std::vector<std::vector< double > > maple_solns, Rational** LC, int** supportmatexp, int l, int m, int n);
void WriteAlphaCertifiedInputFloat(int display, int** supportmatexp, Rational** LC, std::vector<SignPattern> TopBestSigns, int** exp2, int l,int m,int n, int numeq);
void LoadAndDisplayMapleSolutions(int display, std::vector<std::vector<double> > & the_displayed_solns);
void RunMapleScript(std::string filename);
void OutputOriginalVars(Variable* All_Variable_Ptr, int n);

int main(){

    std::cout << "********************\n";
    std::cout << "A program to compute the solutions of a polynomial system that can be transformed into a gale dual system.\n\n";
    std::cout << "********************\n";
    

    // perhaps put this in the file itself for parsing, but not for now, leave it as a user-specified option
    
    int inputc;

    std::cout << "Determine the input type of the file.\n"
              << "1) Fewnomial system.\n"
              << "2) Gale system.\n"
              << "Enter your choice: ";
    std::cin >> inputc;
    
    
    while (inputc != 1 && inputc != 2){ // pretty sure this is ||
        std::cout << "Incorrect option.\n"
                  << "Determine the input type of the file.\n"
                  << "1) Fewnomial system.\n"
                  << "2) Gale system.\n"
                  << "Enter your choice: ";
        std::cin >> inputc;
    }


    std::cout << "1) Display the solutions of the fewnomial system.\n"
              << "2) Display the solutions in the gale system.\n"
	      << "3) Do not display solutions, but display the appropriate dual, i.e. the " 
	      << ( inputc == 1 ? "gale system.\n" : "fewnomial system.\n");
    
    int display;
    
    std::cout << "Enter your choice: ";
    std::cin >> display;

    while (display < 1 || display > 3){// while(display != 1 && display != 2 && display != 3){ // shouldn't this be || ?
        std::cout << "Incorrect option.\n"
                  << "1) Display the solutions of the fewnomial system.\n"
                  << "2) Display the solutions in the gale system.\n"
		  << "3) Do not display solutions, but display the appropriate dual, i.e. the " 
		  << ( inputc == 1 ? "gale system.\n" : "fewnomial system.\n");
        std::cout << "Enter your choice: ";
        std::cin >> display;
    
    }
    
    
    bool realtracking = false; // outside here for scope issues   
    int solvec;    // outside here for scope issues


    if (display != 3){

      std::cout << "Choose an option:\n"
		<< "1) Solve using the Khovanskii-Rolle Real-Tracking Algorithm\n"
		<< "2) Solve using Bertini (standard homotopy continuation methods)\n"
		<< "Enter your choice: ";
      
      
      
      std::cin >> solvec;
      while (solvec != 1 && solvec !=2){ // once more ||
	std::cout << "Incorrect option.\n"
		  << "Choose an option:\n"
		  << "1) Solve using the Khovanskii-Rolle Real-Tracking Algorithm\n"
		  << "2) Solve using Bertini (standard homotopy continuation methods)\n"
		  << "Enter your choice: ";
	
	std::cin >> solvec;
      } // end while
      realtracking = (solvec == 1 ? true : false);
    
    }// end if display != 3

    // get the filename
    
    std::cout << "Enter the filename to parse: ";
    std::string filename;
    std::cin >> filename;
    
    // parse the input -- depending on the choice ...
    
    // these next objects are for a file for the original system
    // will need some others for the conversion from gale to 'original'
    
    int parseresult;
    int numeq, numvar, nummon; // l, m, n? l = nummon - numvar, l + m + n = nummon, numvar = n, (m = 0, pos. dim.)
    int numparam, numlinear;
    int l, m, n;
    // these ALL need to be deleted
    Monomial* All_Mon_Ptr = NULL; 
    Variable* All_Variable_Ptr = NULL;
    Polynomial* All_Polynomials = NULL;
    Rational** LC = NULL;
    int** exponents = NULL;
    std::vector<std::string> TheMasterFunctions;

    if (inputc == 1){
        parseresult = ParseInputOriginal(filename, numeq, numvar, nummon,  
                                         All_Mon_Ptr, 
                                         All_Variable_Ptr, All_Polynomials, LC, 
                                         exponents);
	// write exp.dat
	WriteGAPoutputOriginal(numeq, numvar, nummon, exponents);
	// these should be right . . . 
	n = numvar;
	l = nummon - numvar;
	m = 0;
	std::cout << "n = " << n << ", l = " << l << "\n";
	numlinear = nummon;
	
	std::cout << "In fewnomial input\n\n";

	std::cout << "exponents = \n\n\n";
	for (int i = 0; i < numvar; ++i){
	  for (int j = 0; j < nummon; ++j){
	    std::cout << exponents[i][j] << "\t";
	  }
	  std::cout << "\n";
	}

    }
    else{
      // parse a gale system input


      parseresult = ParseInputGale(filename, All_Variable_Ptr, LC, exponents, numparam, numlinear);
      

      // output exponents
      std::cout << "in gale input\n\n";
      std::cout << "exponents = \n\n\n";
      for (int i = 0; i < numparam; ++i){
	for (int j = 0; j < numlinear; ++j){
	  std::cout << exponents[i][j] << "\t";
	}
	std::cout << "\n";
      }
      
      // we go ahead and put LC in the format as a fewnomial system, we don't know 
      // what the monomials actually are if we know the annihilation of the support
      // we can create an isomorphic choice of the monomials based off of the annihilation vectors
      // but this is not necessary, as regardless of the choice, the solutions will still be the same

      // write gap function for gale dual to compute short null vectors or use the heuristic
      // also use this to compute the null space of the exponents 
      // (i.e. we don't know them right now,
      // but any choice should be isomorphic.)


      WriteGAPoutputGale(exponents, numparam, numlinear);
      


      // these should be right . . . 
      l = numparam;
      m = 0;
      
      std::cout << "numlinear = " << numlinear << "\n\n";
      

      // note that numlinear here, includes the parametrization of the linears (i.e. s0 = s1 = ... = s{l-1} = 0)
      
      n = numlinear - l; // n is the number of variables
                       // l + n is the number of monomials
     
      nummon = numlinear;
      numeq = numlinear - l; // should be the same as n 

    }

    // dimensions of LC should be the same for both parsing
    // the gale system should have already been in RRE form
 

    // for the forking part that calls GAP to compute the
    // generators of the null space
    
    int status;     
    
    pid_t pid = fork();
    
    if (!pid){ // child process -- calling GAP stuff
      system("gap -q exp.dat"); // system call - bad form, but ok for now
      // exit out of one of the forked processes
      // delete the dynamically allocated memory

      // All_Mon_Ptr,
      // All_Variable_Ptr
      // All_Polynomials
      // LC
      // exponents
      
      if (All_Mon_Ptr != NULL){
	delete[] All_Mon_Ptr;
	All_Mon_Ptr = NULL;
      }
      if (All_Variable_Ptr != NULL){
	delete[] All_Variable_Ptr;
	All_Variable_Ptr = NULL;
      }
      if (All_Polynomials != NULL){
	delete[] All_Polynomials;
      }
      for (int i = 0; i < numeq; ++i){
	delete[] LC[i];
      }
      delete[] LC;
     //  exponents have different sizes depending on inputc
      for (int i = 0; i < (inputc == 1 ? numvar : numparam); ++i){
	delete[] exponents[i];
      }
      delete[] exponents;



      return 0;

    } // end system call to gap
    else{
      // this is where we are now  
      // to do : convert gale system back to fewnomial if the choice is the heuristic
      // to be able to compute the heuristic for choice of parametrization
      // then call maple (or write c++ function for l = 2 (and for later l > 2)

      

        int paramchoice;


	// determine the options for choosing good paramtrization
	std::cout << "Choose if you want to use the parametrization provided by the"
		  << " file or use the heuristic in determining a 'good'"
		  << " parametrization.\n";
	std::cout << "1) Parametrization provided by file.\n"
		  << "2) Heuristic.\n";
	
	std::cout << "Enter your choice: ";
	std::cin >> paramchoice;
	while (paramchoice != 1 && paramchoice != 2){
	  std::cout << "Incorrect option.\n";
	  std::cout << "1) Parametrization provided by file.\n"
		    << "2) Heuristic.\n" ;           
	  std::cout << "Enter your choice: ";
	  std::cin >> paramchoice;
	}
	
	
	
	// do the gaussian elimination only if inputc == 1 (i.e. fewnomial input)
	// this reduces some computations, one boolean check versus doing Gaussian Elimination
	// on an already RRE 

	if (inputc == 1){
	  GaussianElimination(LC, numeq, nummon+1);
	}

	// create a vector that will hold all the parametrizations
	// didn't i do this in GAP before ...?
	// this is stored as std::vector<std::vector<int> > where the inside vector is of size l
	
	// these are declare out here for scope issues
	
	std::vector<int> CurrentParam(l);
	for (int i = 0; i < l; ++i){
	  CurrentParam[i] = i;
	}
	std::vector<int> LastParam(l);
	for (int i = 0; i < l; ++i){
	  LastParam[i] = numeq + i; // this was n + i 
	}
	std::vector<int> BestParam; // just store the best parametrization
	// could also keep some of the best ones ?   
	
	BestParam = LastParam; // set it to the last param (i.e. original)
	
	// create a new LC array (exact copy, but keep original intact)
	
	Rational** LC2;
	
	  
	LC2= new Rational*[numeq];
	
	for (int k = 0; k < numeq; ++k){
	  LC2[k] = new Rational[nummon+1];
	}

	for (int k = 0; k < numeq; ++k){
	  for (int j = 0; j < nummon+1; ++j){

	    LC2[k][j] = LC[k][j];
	  }

	}
	
	double BestHeuristicRatio = -1;


	
	  if (paramchoice==2){
	  
	    bool keepgoing = true;
	    while (keepgoing){
	      
	      // set LC2 to the CurrentParam() locations
	      // change the LC2 array based off of the original LC matrix
	      // size is already determined and set . . .
	      // essentially we want to place the columns given from CurrentParam
	      // to n, n + 1, . . . , n + l, respectively
	      // in the LC, but stored in LC2
	      
	      
	      
	      for (int k = 0; k < numeq; ++k){ // this was n
		for (int r = 0; r < nummon + 1; ++r){ // this was l + n + 1
		
		  LC2[k][r] = LC[k][r];
		}
	      }
	      
	      // LC2 is now populated with the original LC
	      // go ahead and base off of CurrentParam, swap columns
	      for (int k = 0; k < CurrentParam.size(); ++k){
		int ColumnToSwap1 = CurrentParam[k];
		int ColumnToSwap2 = n + k;
		// swap for each row
		// go ahead and create two tmps
		// as I don't want to worry about testing
		// if the currentparam is the original
		for (int i = 0; i < n; ++i){
		  Rational Tmp1 = LC2[i][ColumnToSwap1];
		  Rational Tmp2 = LC2[i][ColumnToSwap2];
		  LC2[i][ColumnToSwap1] = Tmp2;
		  LC2[i][ColumnToSwap2] = Tmp1;
		} // end for i
		
	      } // end for k
	      
	      double CurrentHeuristicRatio = HeuristicRatio(LC2, l, n);
	      
	      


	      // test if this heuristic is better than the one we got currently
	      if (BestHeuristicRatio < 0 || CurrentHeuristicRatio > BestHeuristicRatio){
		BestHeuristicRatio = CurrentHeuristicRatio;
		BestParam = CurrentParam;
	      } // end if
	      
	      CurrentParam = Click(CurrentParam, LastParam);
	    
	      
	      // if we are the same as the last one, done with the outermost loop
	      bool keepgoing2 = true;
	      for (int i = 0; i < CurrentParam.size() && keepgoing2; ++i){
		if (CurrentParam[i] != LastParam[i]){
		  keepgoing2 = false;
		} //end if
	      } //end for i
	      if (keepgoing2){
		keepgoing = false;
	      } // end if
	    } // end while


	    // ok, we've exitted the while loop, and did not test the heuristic for the original parametrization
	    // do so now!
	  
	    for (int k = 0; k < n; ++k){
	      for (int r = 0; r < l + n + 1; ++r){
		LC2[k][r] = LC[k][r];
	      } // end for r
	    } // end for k
	    double CurrentHeuristicRatio = HeuristicRatio(LC2, l, n);
	    // std::cout << "CurrentHeuristicRatio = " << CurrentHeuristicRatio << "\n\n";
	    if (BestHeuristicRatio < CurrentHeuristicRatio){
	      BestHeuristicRatio = CurrentHeuristicRatio;
	      BestParam = CurrentParam;
	    }	  
	  
	  
	  } // end paramchoice == 2
	

	
	  ///********* REARRANGE the LC for the different choice of the parametrization ***///
	  // Note that BestParam is set to the Original Parametrization, so as to not have to worry
	  

	  for (int i = 0; i < BestParam.size(); ++i){ // this should be l
	    for (int j = 0; j < n; ++j){ // this needs to be done for each row in LC
	      // but only with the l swaps
	      int ColSwap1 = BestParam[i];
	      int ColSwap2 = n + i;
	      Rational Tmp1 = LC[j][ColSwap1];
	      Rational Tmp2 = LC[j][ColSwap2];
	      LC[j][ColSwap1] = Tmp2;  // we do the extra tmp, on the offchance 
	      LC[j][ColSwap2] = Tmp1;  // we want to swap the 'same' memory address
	      // and assign it that way.
	    }
	  }
	  


        // at this point we assume the LC array is in order, the monomials are
        // rearranged and in order
        // so now we can create the polynomials of the master equations
        // 
        
        
        // perform the gaussian elimination
        
        GaussianElimination(LC, numeq, nummon+1);


        

	
        
	std::cout << "Choose an option:\n"
		  << "1) Use the basis vectors generated by GAP.\n"
		  << "2) Compute Sign Patterns.\n";
	int basisc;
	std::cin >> basisc;
	while (basisc != 1 && basisc !=2){
	  std::cout << "Incorrect input.\n"
		    << "Choose an option:\n"
		    << "1) Use the basis vectors generated by GAP.\n"
		    << "2) Compute Sign Patterns.\n";
	  std::cin >> basisc;
	}
	int zeroc = 0;
	if (basisc == 2){
	  std::cout << "Choose an option:\n"
		    << "1) Throw out 0's in the vectors that form the basis.\n"
		    << "2) Keep 0's in the vectors that form the basis.\n";
	  std::cin >> zeroc;
	  while (zeroc != 1 && zeroc != 2){
	    std::cout << "Incorrect input.\n"
		      << "Choose an option:\n"
		      << "1) Throw out 0's in the vectors that form the basis.\n"
		      << "2) Keep 0's in the vectors that form the basis.\n";
	    std::cin >> zeroc;
	  }
	}

	// now we wait until gap returns the generators
        wait(&status);




	// now we have in the supportmat.dat file, the appropriate, support matrix of the 
	// monomials -- only in the inputc == 2 (gale system input)
	// read this in 

	int** supportmatexp = new int*[n];
	for (int i = 0; i < n; ++i){	
	  supportmatexp[i] = new int[l+m+n];
	} // end for i
	
	if (inputc == 2){
	  std::ifstream finblah("supportmat.dat");
	  std::string thelinefromsupportmat;
	  std::stringstream ss243;
	  int rows = 0; 
	  std::cout << "The support matrix of the fewnomial system generated by gap since the input was the gale system: \n";
	    while (getline(finblah, thelinefromsupportmat)){
	      std::cout << thelinefromsupportmat << "\n";
	      
	      ss243 << thelinefromsupportmat;
	      
	      for (int i = 0; i < l + m + n; ++i){
		
		int cur;
		ss243 >> cur;		
		supportmatexp[rows][i] = cur;
	      } // end for i
	      ++rows;
	    } // end while
	  finblah.close();
	} // end if inputc == 2
	else{
	  for (int i = 0; i < n; ++i){
	    for (int j = 0; j < l+m+n; ++j){
	      supportmatexp[i][j] = exponents[i][j];
	    } // end for j
	  } // end for i
	} // end else

	
	
	// read in the default choice of vectors from GAP
	// (always need these anyway)
	std::vector<SignPattern> OriginalBasis;
	

	std::ifstream fin;                                                                                                                                                             
	fin.open("shortnull.dat");                                                                                                                                                     
	std::string currentstr;   
	std::vector<std::string> VecsAsStrings;
	while(getline(fin,currentstr)){
	  VecsAsStrings.push_back(currentstr);
	} 
	std::stringstream ss1;
	ss1 << VecsAsStrings[0];                                                                                                                                                  
	int dimensions = 0; 
	int currentint1;    
	while (ss1 >> currentint1){
	  ++dimensions;            
	}
	// create a vector for the original signpatterns   
	OriginalBasis = std::vector<SignPattern>(VecsAsStrings.size());                                                                                               
	// std::vector<int> CurrentIntVec = std::vector<int>(dimensions);                                                                                                             
  	for (int i = 0; i < VecsAsStrings.size();++i){                           
	  std::stringstream ss;                                                                                  
	  ss << VecsAsStrings[i];                                                                                                                          
	  int currentint;      
	  int count = 0;
	  OriginalBasis[i].thesigns = std::vector<int>(dimensions);
	  OriginalBasis[i].IntVec = std::vector<int>(dimensions);  
	  while (ss >> currentint){                                
	    // CurrentIntVec[count] = currentint;
	    OriginalBasis[i].thesigns[count] = currentint % 2;                                                             
	    OriginalBasis[i].IntVec[count] = currentint;      
	    ++count; 
	  }                                                                                                                                                                       
	}  

	std::vector<SignPattern> BestSigns; // these are returned from 
	std::vector<SignPattern> TopBestSigns; // this is the container we use regardless
	//	std::vector<SignPattern> SignsToUse;
	if (basisc == 1){
	  TopBestSigns = OriginalBasis;
	}
	// note, this may not be the right number
	// of sign patterns to keep if m \neq 0
	// also note that they should already by 
	// LI.
	// that is, removed +,- pairs ? (not quite if they were right not next to one another)
	// (rarely will happen, write function to remove +- pairs regardless ...)
	// (or make it so that they are not added to begin with ?)
	// (or automatically ... best yet, add sign pattern with more positives!)
	// -- IF #POS = #NEG, FORCE FIRST NONZERO ENTRY TO BE POS.
	// then remove duplicates!
	if (basisc == 2){
	  BestSigns = ComputeBestSigns(OriginalBasis);

	  int l;
	  if (inputc == 1){
	    l = nummon - numvar;
	  }
	  else{
	    l = numparam;
	  }

	  if (zeroc == 1){ // throw out 0's

	    while (TopBestSigns.size() < l){  

	      for (int i = 0; i < BestSigns.size() && TopBestSigns.size() < l; ++i){
		
		if (Zeroes(BestSigns[i]) == 0){
		
		  TopBestSigns.push_back(BestSigns[i]);
		} // end if Zeroes in null vectors -- this should be changed to testing the l x l determinants
	      
	      } // end for i

	    } // end while TopBestSigns.size() < l
	  
	  } // end if
	  if (zeroc == 2){ // keep 0's
	    for (int i = 0; i < l; ++i){
	      TopBestSigns.push_back(BestSigns[i]);
	    } // end for
	  } // end if zeroc == 2
	} // end if basisc == 2

	// Top Best Signs are in TopBestSigns
	
	

        if (paramchoice==2){
	  // swap the exponents to the appropriate order for both the null space annihilating vectrs
	  // and the support matrix
	  for (int i = 0; i < BestParam.size(); ++i){
	    int CoordToSwap1 = BestParam[i];
	    int CoordToSwap2 = n - l + i;
	    for (int j = 0; j < TopBestSigns.size(); ++j){ // do this for each one in TopBestSigns
	      int Exp1 = TopBestSigns[j].IntVec[CoordToSwap1]; // the reason we do this and
	      int Exp2 = TopBestSigns[j].IntVec[CoordToSwap2]; // not some tmp is to gaurantee if the original
                                                               // parametrization is the best parametrization
                                                               // and not assign the same object to itself
	      TopBestSigns[j].IntVec[CoordToSwap1] = Exp2;
	      TopBestSigns[j].IntVec[CoordToSwap2] = Exp1;
	    }
	    // now swap the appropriate columns in the support matrix of the exponents
	    for (int j = 0; j < n; ++j){
	      int supportmatexp1 = supportmatexp[j][CoordToSwap1];
	      int supportmatexp2 = supportmatexp[j][CoordToSwap2];
	      supportmatexp[j][CoordToSwap1] = supportmatexp2;
	      supportmatexp[j][CoordToSwap2] = supportmatexp1;
	    }

	  } 
	  	  
	}
        
	
	
	std::cout << "The Best Vectors that form a basis from the user's choices are: \n\n";
	
	for (int i = 0; i < TopBestSigns.size(); ++i){
	  std::cout << "[";
	  for (int j = 0; j < TopBestSigns[i].IntVec.size();++j){
	    std::cout << TopBestSigns[i].IntVec[j]
		      << (j != TopBestSigns[i].IntVec.size() - 1 ? ", " : "]\n");
	  }
	  
	}
       
	// now we want to go ahead and write the appropriate maple file
	// and then run it, grab the solutions, unwrap, and alphaCertify -- all automatically

	
	// at this point, we should double check that the monomials * the basis vectors is a 0 matrix
	// if not, exit, but we should be good, always




	


	int** exp2 = new int*[l];
	for (int i = 0; i < l; ++i){
	  exp2[i] = new int[TopBestSigns[i].IntVec.size()];
	  for (int j = 0; j < TopBestSigns[i].IntVec.size(); ++j){
	    exp2[i][j] = TopBestSigns[i].IntVec[j];
	  }
	}

	// do a double check that these two matrices gives us the 0 matrix
	// since we are storing the exponent matrix transposed ... 
	// we take the dot product of each row vector in supportmatexp with each row vector in exp2

	for (int i = 0; i < n; ++i){
	  for (int j = 0; j < l; ++j){
	    // row i for supportmatexp
	    // row j for exp2
	    // do a total of l + m + n mults and additions
	    int curresult = 0;
	    for (int k = 0; k < l + m + n; ++k){
	      curresult += supportmatexp[i][k]*exp2[j][k];
	    }
	    if (curresult != 0){
	      //	    std::cout << curresult << "\n";
	      std::cerr << "Something went wrong in the calculation of finding the appropriate"
			<< " null space vectors of the support matrix of the monomials.  This should never happen."
			<< "  Please check your input file. Exitting program.\n\n";
	      return 100; // error return 100
	    }
	  }
	}



	// now, we need to get a Polynomial* of the parametrized polynomials.  There are l + m + n of these (i.e. the truncated linears
	// the top best signs will be moved ot an exponent matrix	
        // get the parametrization polynomials

        // recall that the number of parametrized polynomials in the l+m new vars
        // is the number of monomials
        // create the parametrization polynomial array
        Polynomial* param_poly = new Polynomial[nummon];
        
        // number of variables in the gale system space is
        // nummon - numeq = l+m+n-n=l+m
        int numparammon = nummon - numeq;


	std::cout << "Making the param_poly\n";
	Variable* All_Variable_Ptr2 = new Variable[l+m]; // + m?
	for (int i = 0; i < l + m; ++i){
	  Variable CurV('s', i);
	  All_Variable_Ptr2[i] = CurV;
	}
        for (int i = numeq; i < nummon; ++i){
            
	  stringstream ss2;
	  ss2 << "s_"
	      << i-numeq;
	  
	  
	  Monomial current_mon;
	  //            current_mon.Set(ss2.str());
	  int* curexps = new int[numparammon];
	  for (int j = 0; j < numparammon; ++j){
	    curexps[j] = 0; // safety precaution
	  }
	  curexps[i - numeq] = 1;
	  
	  
	  current_mon = Monomial(Rational(1), All_Variable_Ptr2, curexps, l);
	  Monomial* the_mon = new Monomial[1];
	  the_mon[0] = current_mon;
	  Rational* the_lc = new Rational[1];
	  the_lc[0] = 1;
          
	  param_poly[i] = Polynomial(the_mon,the_lc,1);
	  delete[] the_mon;
	  delete[] the_lc;
        }

	delete[] All_Variable_Ptr2;
	
        for (int i = 0; i < numeq; ++i){
	  // remember to add 1 for the constant
	  Monomial* the_mon = new Monomial[numparammon+1];
	  Rational* the_lc = new Rational[numparammon+1];
          
	  for (int j = 0; j < numparammon; ++j){
	    the_mon[j] = param_poly[j+numeq].Monomials[0];
	    the_lc[j] = -1*LC[i][j+numeq];
	  }
	  // set the last Monomial to the constant
	  the_mon[numparammon] = Monomial();
	  the_lc[numparammon] = -1*LC[i][nummon];
	  param_poly[i] = Polynomial(the_mon, the_lc, numparammon+1);
	  delete[] the_mon;
	  delete[] the_lc;
        }
	
	
	std::cout << "The parameter polynomials are : " << std::endl << std::endl;
        for (int i = 0; i < nummon; ++i){
	  std::cout << "p_" << i << ":=" << param_poly[i] << std::endl;
        }
        	
	// now set up the Polynomal* All_Poly, i.e. the fewnomial system
	// now, since everything has been properly changed if the heuristic
	// was used, we can set up the monomials All_Mon (assuming we are in inputc == 2
	// OR swap those if we are in inputc==1)
	
	
	Monomial* All_Mon_Ptr2 = new Monomial[nummon + 1];




	// right .. so here we have to delicately tread the situation with the variable names
	// when our input is a fewnonmial system, i.e. inputc == 1
	// we can use All_Variable_Ptr
	// if our inputc == 2
	// we need to create a new All_Variable_Ptr 
	// (apart from All_Variable_Ptr2, which was deleted, and also doesn't have the correct number of monomials anyway)
	// 
	
	
	Variable* All_Variable_Ptr3;
	if (inputc == 2){
	  All_Variable_Ptr3 = new Variable[n];
	  
	  for (int i = 0; i < n; ++i){
	    // it doesn't matter what we call the Variable, so we'll just do x0, x1, ... , x{n-1}
	    Variable CurV('x', i);
	    All_Variable_Ptr3[i] = CurV;
	  }
	}
	else{
	  All_Variable_Ptr3 = NULL;
	}
	
	
	std::cout << "The Monomials are: \n\n";
	
	
	for (int i = 0; i < nummon; ++i){

	  // create the current Monomial based off of the exponents
	  Rational Coefficient = Rational(1);
	  
	  // create the appropriate monomial exponent structure
	  int* curexps;
	
	  curexps = new int[n];
	  
	  for (int j = 0; j < n; ++j){ 
	    curexps[j] = supportmatexp[j][i];
	  }
	  

	  Monomial M1 = Monomial(Coefficient, (inputc == 1 ? All_Variable_Ptr : All_Variable_Ptr3), curexps, n);
	  
	  All_Mon_Ptr2[i] = M1;
	 
	  std::cout << "m_" << i << " := " << M1 << "\n";
	  // if (i != nummon){
	  
	  delete[] curexps;
	
	}

	//	Monomial MyConst();
	// set the last monomial to the constant monomial
	All_Mon_Ptr2[nummon] = Monomial();
	//std::cout << "\nBefore delete[] All_Variable_Ptr3\n";


	/*  DELETE THIS MEMORY ELSEWHERE!	
	if (All_Variable_Ptr3 != NULL){
	  std::cout << "Deleting All_Variable_Ptr3 \n\n";

	  delete[] All_Variable_Ptr3;
	}

	*/
	//	std::cout << "\n\n*here1*\n\n";

	
	if (All_Polynomials != NULL){
	  delete[] All_Polynomials;
	  All_Polynomials = NULL;
	}
	
	All_Polynomials = new Polynomial[numeq];
	std::cout << "The Polynomials are: \n";
	for (int i = 0; i < n; ++i){
	  Polynomial P(All_Mon_Ptr2, LC[i], nummon+1);
	  All_Polynomials[i] = P;
	  std::cout << P << "\n";
	}
	
	if (display != 3){
	  
	  if (solvec==1){
	    
	   OutputOriginalVars((inputc == 1 ? All_Variable_Ptr : All_Variable_Ptr3), n);	    
	   WriteMapleOutput(filename, l, m, n, param_poly, exp2, supportmatexp, All_Polynomials, (inputc == 1 ? All_Variable_Ptr : All_Variable_Ptr3) );
	    
	   RunMapleScript(filename);

	   //	   int status2;
	   // pid_t pid2 = fork();
	   //if (!pid2){
	    
	     
	     
	   // return 0;
	   // } // end !pid2
	    //else{
	    //  wait(&status2);
	      // maple script is done being called
	      // load up solutions from maple
	   std::vector<std::vector<double> > maple_solns;
	      
	   LoadAndDisplayMapleSolutions(display, maple_solns);
	      
	      // write an alphacertifiedinput file, dependent on display choice
	 
	   WriteAlphaCertifiedInputFloat(display,supportmatexp, LC, TopBestSigns, exp2, l, m, n, numeq);
	   WriteAlphaCertifiedSolutionsFloat(display, maple_solns, LC, supportmatexp, l,m,n);
	   
	   // write an initial settings file
	   
	   int algorithm = 2;
	   int arithmetictype = 1;
	   int precision = 192;
	   int refinedigits = 0; // for now?
	   int numrandomsystems = 2;
	   int randomdigits = 10;
	   int newtononly = 1;
	   int numiterations = 1;
	   int realitycheck = -1;
	   int realitytest = 0;	      
	   bool isCertified = false;
	   
	   
	   // ask the user for the maximum number of newton iterations to perform, otherwise, we may not have a stopping criterion
	   
	   int currentiter, maxiterations = 0;
	   
	   std::cout << "Enter the max number of times to automatically test if the solutions are alphaCertified: ";
	   std::cin >> maxiterations;
	   while (maxiterations <= 0){
	     std::cout << maxiterations << " is an incorrect option. \n";
	     std::cout << "Enter the max number of times to automatically test if the solutions are alphaCertified: ";
	     std::cin >> maxiterations;
	   } // end while maxiterations <= 0
	   
	   bool continueToCertify = true;
	   while(!isCertified && continueToCertify){
	     
	     newtononly = 1;
	     if (currentiter != 0){ // i.e., not the first time around, bump up precision by 2
	       precision*=2;
	       
		  // and rewrite the settings file
	       //writeAlphaCertifiedSettings(algorithm, arithmetictype, precision,refinedigits,
			//		   numrandomsystems, randomdigits, newtononly, numiterations, realitycheck, realitytest);
	       
	     } // end if currentiter != 0
	     writeAlphaCertifiedSettings(algorithm, arithmetictype, precision,refinedigits,
					 numrandomsystems, randomdigits, newtononly, numiterations, realitycheck, realitytest);		
	     
	     std::stringstream fnamess2, fnamesolutions;
	     fnamess2 << "alphaCertifiedInput_" << (display == 1 ? "fewnomial_solutions" : "gale_solutions");
	     fnamesolutions << "solutionsToCertify_" << (display == 1 ? "fewnomial_solutions" : "gale_solutions");
	     std::stringstream systemss;
	     
	     systemss << "alphaCertified " << fnamess2.str() << " " << fnamesolutions.str() << " alphaCertifiedSettings";
		   std::cout << "Calling " << systemss.str() << "\n\n"; 
		system(systemss.str().c_str());
	     
	     // now we have refined the points using a newton iteration
	     // do a copy of refinedPoints to fnamess2.str().c_str()
	     
	     std::stringstream copyss;
	     copyss << "cp " << "refinedPoints " << fnamesolutions.str();
	     system(copyss.str().c_str());
	     
	     
	     // now this will actually perform alphaCertified on the solutions that have been refined by a newton iteration
	     
	     newtononly = 0;
	     
	     // rewrite the settings file
	     writeAlphaCertifiedSettings(algorithm, arithmetictype, precision,refinedigits,
					 numrandomsystems, randomdigits, newtononly, numiterations, realitycheck, realitytest);
	     system(systemss.str().c_str());
	     
	     
	     // test if certified
	     isCertified = isAlphaCertified();
	     if (!isCertified){
	       // increase the current number of iterations
	       ++currentiter;
	     }
	     
	     
	     //		while (!isCertified && currentiters < maxiterations){
	     
	     if (currentiter >= maxiterations){
	       continueToCertify=false;
	     }
	     
	     
	     if (!continueToCertify && !isAlphaCertified){
	       
	       std::cout << "The " << (display == 1 ? "fewnomial " : "gale ") << "solutions are not soft-certified solutions"
			 << " after " << currentiter << " iterations.\n\n";	      
	       
	       std::cout << "Would you like to display the summary file produced by alphaCertify? (y/n)  ";
	       std::string displaysum;
	       std::cin >> displaysum;
	       while (displaysum.compare("y") != 0 & displaysum.compare("n") != 0 & displaysum.compare("Y") != 0 & displaysum.compare("N") != 0){
		 std::cout << "Invalid input. Display the summary file? (y/n)  ";
		 std::cin >> displaysum;
	       }
	       
	       if (displaysum.compare("y") == 0 || displaysum.compare("Y") == 0){
		 std::ifstream finsum("summary");
		 std::string ablankline;
		 while(getline(finsum,ablankline)){
		   std::cout << ablankline << "\n";
		 }
		 std::cout << "\n\n";
	       }
	       
	       std::cout << "Would you like to perform more iterations of alphaCertify or stop? (y/n)  ";
	       std::string performmore;
	       std::cin >> performmore;
	       
	       while (performmore.compare("y") != 0 & performmore.compare("n") != 0 & performmore.compare("Y") != 0 & performmore.compare("N") != 0){
		 std::cout << "Invalid input.  More iterations ? (y/n)  ";
		 std::cin >> performmore;
	       }
	       
	       if (performmore.compare("y") == 0 || performmore.compare("Y") == 0){
		 continueToCertify = true;
		 // ask how many more newton iterations
		 std::cout << "How many more iterations would you like to perform:  ";
		 int moreiters;
		 std::cin >> moreiters;
		 while (moreiters <= 0){
		   std::cout << "Invalid input. Increased number of iterations must be more than 0.  Enter additional number of iterations to perform:  ";
		      std::cin >> moreiters;
		 } // end while
		 maxiterations+=moreiters;
	       } // end perform more
	       
	     }  // end test if isCertified and continueToCertify
	     
	   } // end while isCertified and continueToCertify

	      

	   // regardless, the latest solutions are sitting in refinedPoints and we can output the screen
	   
	   std::cout << "The " << (display == 1 ? "fewnomial " : "gale ") << "solutions are " << (isCertified ? "" : "not ") << "(soft) alphaCertified"
		     << " after " << currentiter+1 << " iterations.\n\n";	      
	   std::cout << "\n\n";
	   
	   std::cout << "Would you like to display the solutions? (y/n)  ";
	   std::string displaysolns;
	   std::cin >> displaysolns;
	   while (displaysolns.compare("y") != 0 & displaysolns.compare("n") != 0 & displaysolns.compare("Y") != 0 & displaysolns.compare("N") != 0){
	     std::cout << "Invalid input.  Display the solutions? (y/n)  ";
	     std::cin >> displaysolns;
	   }
	   std::vector< std::vector<std::string> > TheRefinedStrings;	
	   //	      if (displaysolns.compare("y") == 0 || displaysolns.compare("Y") == 0){
	   std::ifstream finrefined("refinedPoints");
		  if (displaysolns.compare("y") == 0 || displaysolns.compare("Y") == 0){
	   std::cout << "The soft certified solutions are : \n\n";
		  }
	   std::string aline;
	   getline(finrefined, aline); // gets the number of solutions
	   getline(finrefined, aline); // gets the next blank space
	   
	   std::vector<std::string> CurSolnString;
	   while(getline(finrefined, aline)){
	     if (displaysolns.compare("y") == 0 || displaysolns.compare("Y") == 0){
	       std::cout << aline << "\n";
	     }
	     if (aline.compare("") == 0){
	       TheRefinedStrings.push_back(CurSolnString);
	       CurSolnString.resize(0);
	     }
	     else{
	       CurSolnString.push_back(aline);
	     }
	   } // end while
	   if (isCertified){
	     


	     std::cout << "Hard certification can be done at this point by changing the floating point numerical values "
		       << "into an appropriate rational value and re-running alphaCertify.  Would you like to do this now? (y/n)  ";
	     std::string hardCertify;
	     std::cin >> hardCertify;
	     while (hardCertify.compare("y") != 0 & hardCertify.compare("n") != 0 & hardCertify.compare("Y") != 0 & hardCertify.compare("N") != 0){
	       std::cout << "Invalid input.  Hard Certify ? (y/n) \n";
	       std::cin >> hardCertify;
	     } // end while hardcertify has imporoper input
	     if (hardCertify.compare("y") == 0 | hardCertify.compare("Y") == 0){
	       
	       // hard certify is requested		  
	       // we stored the solutions as strings from refinedPoints, regardless (so as to not have to re-read in the file again, and mem is cheap)
	       // we need to remove the '.' and count the extra digits (if we have e-n)
	       // for the appropriate denominator
	       // the '.' is always a character 
	       
	       
	       writeAlphaCertifiedSolutionsRational(TheRefinedStrings, (display == 1 ? "fewnomial_solutions" : "gale_solutions"));
	       
	       arithmetictype = 0;
	       newtononly = 0;
	       writeAlphaCertifiedSettings(algorithm, arithmetictype, precision,refinedigits,
					   numrandomsystems, randomdigits, newtononly, numiterations, realitycheck, realitytest);
	       
		  
		  
	       // run alphaCertified with hard (rational) certification
	       std::stringstream systemss;
			 std::stringstream fnamess2;
		   fnamess2 << "alphaCertifiedInput_" << (display == 1 ? "fewnomial_solutions" : "gale_solutions");
			 
			 systemss << "alphaCertified " << fnamess2.str() << " solutionsToHardCertify_" << (display == 1  ? "fewnomial_solutions" : "gale_solutions") << " alphaCertifiedSettings";
	       system(systemss.str().c_str());
	       
	       
	       
	     } // end if hardCertify compare


	      
	      
	      
	   } // end isCertified 
	    
	  } // end solvec == 1
	  else{ // begin solvec == 2, i.e. do bertini on the gale functions
	    

	    // writegalesystemtobertini and call bertini!



	  }  // end solvec != 1, i.e. solve gale with bertini
	    

	} // end display != 3  
		else{

			
			
			std::cout << "Displaying the appropriate dual, i.e. the "
					  << (inputc == 1 ? "gale system.\n\n" : "fewnomial system.\n\n");
			
			if (inputc == 1){ // inputc is the fewnomial system
				// output the gale system
				// gale system is stored in parameter polynomials + exp2, i.e.
				// param_poly
				// exp2 holds the basis vectors for the null space
				
				for (int i = 0; i < l; ++i){
					std::stringstream sspos; 
					sspos << ""; // the positive exponent portion of the string of the master function
					std::stringstream ssneg; 
					ssneg << ""; // the negative exponent portion of the string of the master function
					for (int j = 0; j < l + m + n; ++j){
						std::stringstream cur;
						cur << "";
						
						cur << "(" << param_poly[j] << ")^";
						if (exp2[i][j] < 0){
							if (ssneg.str().compare("") != 0){ // not the empty string, so throw on a '*'
								ssneg << "*";
							} // end if compare
							ssneg << cur.str() << -exp2[i][j];
						} // end if exp2[i][j] < 0
						else{  
							if (sspos.str().compare("") != 0){ // not the empty string, so throw on a '*'
								sspos << "*";
							} // end if compare
							sspos << cur.str() << exp2[i][j];
						} // end else
					}  // end for j
					std::cout << "M_" << i << " := 0 = " << (sspos.str().compare("") != 0 ? sspos.str() : "1") << "\n\t    - " 
							<< (ssneg.str().compare("") != 0 ? ssneg.str() : "1") << "\n";
				}	    
			} // end inputc == 1
			else{ // inputc is the gale system
				// output the fewnomial system
				// fewnomial system is stored in All_Polynomials
				for (int i = 0; i < n; ++i){
					std::cout << "P_" << i << " := " << All_Polynomials[i] << "\n";
				} // end for
				
			} // end else
	
		} // end displayc == 3
    
	} // end system call to gap


    return 0;
}










// go through and figure out display of fewnomial or gale system solutions, depending on choice
// this will amount to not unwrapping within the maple program
// and read in the solution from the tracker



// (i.e. edit the script to have the tracker write the solutions
// in a bertini type output file for real solutions (i.e. num_solutions and the solution vectors and the coordinates within each vector separated by spaces

// also change heuristic to l = 2 case only, and copy over the 'sorting' of the vertices as done in maple

// only thing left in maple is the 'real' arc-length predictor

// to do last: ... go through and check memory leaks 




/// modularizing code ...


void writeAlphaCertifiedSolutionsRational(std::vector<std::vector<std::string> > TheRefinedStrings, std::string filename){

  std::stringstream somestringstream;
  somestringstream << "solutionsToHardCertify_" << filename;
  std::ofstream finhard(somestringstream.str().c_str());
  
  finhard << TheRefinedStrings.size() << "\n\n"; // this is the number of solutions
  for (int i = 0; i < TheRefinedStrings.size(); ++i){
    for (int j = 0; j < TheRefinedStrings[i].size(); ++j){
      std::stringstream curss;
      curss << TheRefinedStrings[i][j];
      std::string curstring;
      curss >> curstring; // this removes the imaginary component, as stringstream insertion and extraction operators
      // are space delimited
      int dotloc = curstring.find(".");
      curstring.erase(1,dotloc);
      //		      curstring.erase(1,1); // this removes the decimal ('.')
      // now we need to check if there is an e-n in the string
      int eloc = curstring.find("e-");
      if (eloc != std::string::npos){
	// we found "e-"
	// get the substring that corresponds to the exponent
	std::string mysub = curstring.substr(eloc + 2); // go to the end of the string
	// now place this on a stringstream
	std::stringstream anotherss;
	anotherss << mysub;
	int theexp;
	anotherss >> theexp;
	// now get the substring that does not have the 
	// addition "e-" stuff at the end
	std::string mysub2 = curstring.substr(0, eloc);
	finhard << mysub2 << "/1";
	// now determine the number of 0's to add 
	for (int lmno = 0; lmno < mysub2.size() + theexp - 1; ++lmno){
	  finhard << "0";
	} // end for lmno
	// determine if '-'
	if (mysub2[0] != '-'){
	  finhard << " 0\n";
	}
	
      } // end if eloc = npos
      else{ // end else
	// we did not find "e-"
	finhard << curstring << "/1";
	for (int lmno = 0; lmno < curstring.size() - 1; ++lmno){
	  finhard << "0";
	} // end for lmno
	if (curstring[0] != '-'){
	  finhard << " 0\n";
	}
      } // end else
      
    } // end for j
    finhard << "\n";
  } // end for i
  finhard.close();
  
  
}


bool isAlphaCertified(){
  // read in isRealSoln and make sure that each value is a '1' after the number of solutions line
  std::ifstream fin8202("isRealSoln");
  std::string curline845;
  getline(fin8202, curline845);
  
  std::stringstream solnnumss;
  solnnumss << curline845;
  int numsolutionsinfile;
  solnnumss >> numsolutionsinfile;
  getline(fin8202, curline845); // corresponds to a space
  int currentsolnstested = 0;
  std::cout << "numsolutionsinfile = " << numsolutionsinfile << "\n\n";
  bool found1 = true; // this is used to test if we are certified
  while (currentsolnstested < numsolutionsinfile){
    
    
    getline(fin8202, curline845);
    int val = 0;
    std::stringstream anss;
    anss << curline845;
    anss >> val;
    getline(fin8202, curline845); // for the space
    
    if (val != 1){
      found1 = false;
    }
    ++currentsolnstested; // this is solutions found in file
    
  } // end while 

  return found1;


  
}


void WriteAlphaCertifiedSolutionsFloat(int display, std::vector<std::vector< double > > maple_solns, Rational** LC, int** supportmatexp, int l, int m, int n){

  std::string filename;
  std::stringstream fnamesolutions;
	std::vector<int> negexp; // just keep track of which monomial has a negative exponent, i.e. the columns
    for (int j = 0; j < l + m + n; ++j){
		bool foundneg = false;
		//		  std::vector<int> curmonneg;
		for (int i = 0; i < n; ++i){
			if (supportmatexp[i][j] < 0){
				//  curmonneg.push_back(i); // the i'th variable for the j'th monomial has a negative exponent
				foundneg = true;
				
			}
		}
		if (foundneg){
			// go ahead and push pair(curmmonneg,j) onto negexp
			//
			
			//	    negexp.push_back(std::pair<std::vector<int>, int>(curmonneg,j));
			negexp.push_back(j);
		}
    } // end for j
	
	if (display == 1){
    filename = "fewnomial_solutions";
    std::vector< std::vector<double> > new_solns;
    for (int i = 0; i < maple_solns.size(); ++i){
      
      std::vector<double> cursoln = maple_solns[i];
      
      for (int j = 0; j < negexp.size(); ++j){
	// get the column on which we have monomials with negative exponents
	int thecolumn = negexp[j];
	double curval = 1;
	for (int k = 0; k < n; ++k){
	  if (supportmatexp[k][thecolumn] < 0){
	    curval*=pow(double(cursoln[k]), -supportmatexp[k][thecolumn]);
	  } // end if
	} // end k
	curval = 1 / curval;
	cursoln.push_back(curval);
		  } // end j
      new_solns.push_back(cursoln);
    } // end i
    
    
    // now from here, we go ahead and write to a new file the appropriate values (remember 0 for the imaginary part)
    
    
    fnamesolutions << "solutionsToCertify_"
		   << filename;
    
    std::ofstream fout5678(fnamesolutions.str().c_str());
    fout5678 << new_solns.size() << "\n\n";
    for (int i = 0; i < new_solns.size(); ++i){
      for (int j = 0; j < new_solns[i].size(); ++j){
	fout5678 << new_solns[i][j] << " 0" << "\n";
      }
      fout5678 << "\n";
    }
    fout5678.close();
  } // end if display == 1
  

  else{  // begin else, i.e.  display == 2
    filename = "gale_solutions";
    fnamesolutions << "solutionsToCertify_"
		   << filename;
    
    std::ofstream fout5678(fnamesolutions.str().c_str());
    fout5678 << maple_solns.size() << "\n\n";
    for (int i = 0; i < maple_solns.size(); ++i){
      
      
      // ************ HHHHHHHHHHHEEEEEEERRRRREEEEEEEE ***************** //
      // here we have to write the appropriate solutions
      // for the additional linears!!!!
      // these actually correspond to the first n variables (as opposed to the last n)
      // the last l solutions correspond to the ones we get from the maple program
      // which are currently stored in maple_solns
      
      // OK ... attempt a small hack, since the maple file
      // even if the linears are passed in with rational coefficients
      // will go ahead and change the master functions
      // that is being tracked to linears
      // with integer coefficients
      // 
      
		  
      // ok we need to evaluate the j linears
      for (int j = 0; j < n; ++j){
	// we will be adding together l + 1 terms
	
	// we will need to multiply by the largest denominator found in the linear -- see hack info above
	int largestdenom = 1;
	for (int k = n; k < l + n + 1; ++k){
	  //		      std::cout << "j, k = " << j << ", " << k "\n";
	  
	  if (LC[j][k].GetDenominator() > largestdenom){
	    largestdenom = LC[j][k].GetDenominator();
	  } // end if
	} // end for k
	
	
	double curlinearval = 0;
	for (int k = 0; k < l; ++k){
	  // get the current rational i.e. LC[j][n+k];
	  Rational CurRat = -1*LC[j][n+k]; // should this be -1* ? 
	  // turn the rational into a double
	  double ratasdub = double(CurRat.GetNumerator())/double(CurRat.GetDenominator());
	  // we should multiply ratasdub by the_displayed_solns[i][k];
	  ratasdub*=maple_solns[i][k];
	  
	  // add this to the current linear value
	  curlinearval += ratasdub;		      
	} // end for k

	
	
	Rational CurConstRat = -1*LC[j][n + l];
	curlinearval+=(double(CurConstRat.GetNumerator())/double(CurConstRat.GetDenominator()));
	
	// multiply curlinlinearval by largestdenom
	//		    curlinearval*=largestdenom;
	
	fout5678 << curlinearval << " 0\n"; // should this be -curlinearval ?
      }
      

      for (int j = 0; j < maple_solns[i].size(); ++j){
	fout5678 << maple_solns[i][j] << " 0" << "\n";
      }
      
        
      fout5678 << "\n";
    }
    fout5678.close();
       
  }
  
}

void WriteAlphaCertifiedInputFloat(int display, int** supportmatexp, Rational** LC, std::vector<SignPattern> TopBestSigns, int** exp2, int l,int m,int n, int numeq){
  
  std::string filename;
  if (display == 1){
    filename = "fewnomial_solutions";
  }
  else{
    filename = "gale_solutions";
  }
 
  
  std::stringstream fnamesolutions;
  std::stringstream fnamess2;
  fnamess2 << "alphaCertifiedInput_" << filename;
  //	      std::string filename2 = "alphaCertifiedInput_";
  //filename2.append(f);
  std::ofstream fout280(fnamess2.str().c_str());
 
	std::vector<int> negexp; // just keep track of which monomial has a negative exponent, i.e. the columns
    for (int j = 0; j < l + m + n; ++j){
		bool foundneg = false;
		//		  std::vector<int> curmonneg;
		for (int i = 0; i < n; ++i){
			if (supportmatexp[i][j] < 0){
				//  curmonneg.push_back(i); // the i'th variable for the j'th monomial has a negative exponent
				foundneg = true;
				
			}
		}
		if (foundneg){
			// go ahead and push pair(curmmonneg,j) onto negexp
			//
			
			//	    negexp.push_back(std::pair<std::vector<int>, int>(curmonneg,j));
			negexp.push_back(j);
		}
    } // end for j
	
	if (display == 1){ // we loaded the fewnomial solutions
    
    // we have a laurent polynomial system, i.e. possibly negative exponents
    // run through the list of the monomials, and see which monomials
    // have - exponents.
    // group all negative exponents together in a monomial as a new variable
    // and add the new variable constraints as an equation 
    // at the end
    
    // keep track of which monomials (i.e. which column in supportmatexp)
    // had a negative exponent, so as to be able to simply create the
    // new variable constraint equations simply
    
    //		int monswithnegexpcount = 0;
    // std::pair< std::vector<int>, int > negexp;
  /*  std::vector<int> negexp; // just keep track of which monomial has a negative exponent, i.e. the columns
    for (int j = 0; j < l + m + n; ++j){
      bool foundneg = false;
      //		  std::vector<int> curmonneg;
      for (int i = 0; i < n; ++i){
	if (supportmatexp[i][j] < 0){
	  //  curmonneg.push_back(i); // the i'th variable for the j'th monomial has a negative exponent
	  foundneg = true;
	  
	}
      }
      if (foundneg){
	// go ahead and push pair(curmmonneg,j) onto negexp
	//
	
	//	    negexp.push_back(std::pair<std::vector<int>, int>(curmonneg,j));
	negexp.push_back(j);
      }
    } // end for j
    */
    // we now have negexp.size() more variables and equations
    
    // essentially run alpha certify until everything is certified
    fout280 << n + negexp.size() << " " << n + negexp.size() << "\n\n";
    
    // now output the monomial information and the coefficients
    for (int i = 0; i < n; ++i){ // so this is for the original 'n' equations
      
      fout280 << l + 2 << "\n"; // we have l + 1 monomials each time
      
      int monswithnegexp2 = 0;
      for (int j = 0; j < l + 1; ++j){ // in each equation we have l + 1 monomials (+ constant, which is done after the for j loop
	int columnformon = 0; 
	if (j == 0){
	  columnformon = i + j;
	}
	else{
	  columnformon = n + j - 1;
	}
	bool hadneg = false;
	for (int k = 0; k < n; ++k){
	  if (supportmatexp[k][columnformon] >=0){ // positive exponent
	    fout280 << supportmatexp[k][columnformon] << " ";
	  }
	  else{
	    fout280 << "0 ";
	    hadneg = true;
	  }
	}
	if (hadneg){
	  // we had a negative exponent in the (i + j)'th monomial
	  // find the corresponding index that this relates to in negexp
	  int k = 0;
	  bool foundindy = false;
	  for (; k < negexp.size() && !foundindy; ++k){
	    // just do a simple linear search on the monomials
	    // to determine the index in the negexp vector
	    if (negexp[k] == columnformon){
	      foundindy = true;
	    }
	  }
	  // k-1 is now the index on which we have found the corresponding i + j'th monomial, in the negexp
	  // container
	  
	  for (int l952 = 0; l952 < negexp.size(); ++l952){
	    if (l952 == k - 1){
	      fout280 << "1 ";
	    }
	    else{
	      fout280 << "0 ";
	    }
	  }
	}
	else{
	  // we didn't have a negative exponent, so just output '0's for the new variable exponents
	  for (int l82 = 0; l82 < negexp.size(); ++l82){
	    fout280 << "0 ";
	  }
	}
	
	
	// now we add the corresponding coefficient here
	fout280 << LC[i][columnformon] << " 0\n";
	
	
	
      } // end for j
      // now we need to add the constant monomial information
      
      for (int j = 0; j < n + negexp.size(); ++j){
	fout280 << "0 ";
      }
      fout280 << LC[i][l+m+n] << " 0\n";
    } // end for i -- this does the first n 'original equations
    for (int i = 0; i < negexp.size(); ++i){
      // there will be two monomials, the saturated term, and the constant
      fout280 << "2\n";
      // get the current column that corresponds to this monomial, stored in the .second of the current i'th pair of negexp
      int thec = negexp[i];
      for (int j = 0; j < n; ++j){
	if (supportmatexp[j][thec] >= 0){
	  fout280 << "0 ";
	} // end if
	else{
	  fout280 << -supportmatexp[j][thec] << " ";
	} // end else
      } // end for j
      for (int j = 0; j < negexp.size(); ++j){
	if (i == j){
	  fout280 << "1 ";
	}
	else{
	  fout280 << "0 ";
	}
      } // end for j
      // now add the coefficient for this monomial (i.e. 1)
      fout280 << "1 0\n";
      // now do a line for the constant
      for (int j = 0; j < n + negexp.size(); ++j){
	fout280 << "0 ";
      } // end j
      // done with the exponents of the constant being all 0
      // now add the coefficient for the constant monomial (i.e. -1)
      fout280 << "-1 0\n";
    } // end for i
  }
  else{ // display == 2 i.e. gale_solutions
    fout280 << l + n << " " << l + n<< "\n\n";
    
    // now, for the first l equations, we will have 2 terms and no constant term
    for (int i = 0; i < l; ++i){
      fout280 << "2\n";
      // now we need to create the appropriate positive and negative terms
      // dependent on the exponents found in exp2
      // note that the last l vals from the exp2 correspond to the exponents
      // of the s_i's
      for (int j = 0; j < TopBestSigns[i].IntVec.size(); ++j){ // this should be l + n
	if (exp2[i][j] >= 0){ // this corresponds to the positive exponent term
	  fout280 << exp2[i][j] << " ";
	}
	else{ // the exponent is negative and is not found in the first term
	  fout280 << "0 ";
	}
      }
      fout280 << "1 0\n"; // this is now set to have a LC of 1
      for (int j = 0; j < TopBestSigns[i].IntVec.size(); ++j){
	if (exp2[i][j] <= 0){ // this corresponds to the negative exponent term
	  fout280 << -1*exp2[i][j] << " ";
	}
	else{
	  fout280 << "0 ";
	}
      }
      fout280 << "-1 0\n"; // this is to have a LC of -1
    }
    // now do the 'new' equations for the linear replacement variables
    // i.e. x_0 - l_0 = 0, or x_0 - (1/2*s0+2*s1-1)
    
    
    // OK ... attempt a small hack, since the maple file
    // even if the linears are passed in with rational coefficients
    // will go ahead and change the master functions
    // that is being tracked to linears
    // with integer coefficients
    // i.e. instead of x0 - l0 = 0, x0 - (1/2*s0 + 2*s1 - 1)
    // we have that ' x0 - (s0 + 4*s1 - 2) ' 
    
    
    // we will have a total of 2 + l terms (1 replacement variable + 1 constant + l parameters)
    // we have a total of n new equations
    for (int i = 0; i < n; ++i){
      
      
      // inside of here i want to determine the largest denominator in the current linear
      // i.e. i is for each equations, for n to n + l + 1, find largest denominator and multiply accordingly
      
      int largestdenominator = 1;
      for (int j = n; j < n + l + 1; ++j){
	//  std::cout << "i, j = " << i << ", " << j "\n";
	if (LC[i][j].GetDenominator() > largestdenominator){
	  largestdenominator = LC[i][j].GetDenominator();
	}
      }
      
      
      // this block is for the first term
      fout280 << 2 + l << "\n";
      for (int j = 0; j < l + m + n; ++j){
	if (i == j){
	  fout280 << "1 ";
	} // end if
	else{
	  fout280 << "0 ";
	}
      } // end for j
      fout280 << "1 0\n";
      
      
      // this block is for the next l terms
      for (int j = 0; j < l; ++j){
	for (int k = 0; k < n; ++k){
	  fout280 << "0 ";
	} // end for k
	for (int k = 0; k < l; ++k){
	  if (j == k){
	    fout280 << "1 ";
	  }
	  else{
	    fout280 << "0 ";
	  }
	}
	
	
	// now we want to put the appropriate rational value for the linear here
	fout280 << LC[i][j + numeq]; // *Rational(largestdenominator, 1); // added *largestdenominator
	fout280 << " 0\n";
		  
	
      } // end for j
      
      // this block is for the constant term in the linear
      for (int j = 0; j < l + m + n; ++j){
	fout280 << "0 ";
      }
      fout280 << LC[i][l+m+n]; // *Rational(largestdenominator, 1); // added *largestdenominator
      fout280 << " 0 \n";
    } // end for i
  } // end else, i.e. display == 2
  
  fout280.close();
  
}





void LoadAndDisplayMapleSolutions(int display, std::vector<std::vector<double> > & the_displayed_solns){

	      // load up the solutions depending on the choice,
	      // run alphaCertify unto solutions are certified
	      // and then display the solutions

	      std::string filename;
	      std::ifstream finnow;

	      if (display == 1){ // this corresponds to the fewnomial system
		filename = "fewnomial_solutions";
		finnow.open(filename.c_str());		
	      }
	      if (display == 2){ // this corresponds to the gale system
		filename = "gale_solutions";
		finnow.open(filename.c_str());
	      }

	      // store the solutions in 'the_displayed_solns'
	      // get the number of solns -- first line
	      
	      std::stringstream mycurss;
		
	      std::string curline;
	      getline(finnow, curline);
	      mycurss << curline;
	      int num_solns;
	      mycurss >> num_solns;
	      // resize the displayed_solns vector
	      
	      the_displayed_solns.resize(num_solns);
	      // get one additional line, for the newline
	      getline(finnow, curline);
	      std::vector<double> cursoln;
	      int curnumsolnsreadin = 0;
	      while(curnumsolnsreadin < num_solns){
		getline(finnow, curline);
		if (curline.compare("") == 0){
		  // on a new solution
		  the_displayed_solns[curnumsolnsreadin] = cursoln;
		  ++curnumsolnsreadin;
		  // resize cursoln
		  cursoln.resize(0);
		}
		else{
		  std::stringstream mycurss2;
		  mycurss2 << curline;
		  double curval;
		  mycurss2 >> curval;
		  cursoln.push_back(curval);
		}
	      } 
	      std::cout << "\n";
	      // now, as a quick sanity test, output the current displayed solutions
	      for (int i = 0; i < the_displayed_solns.size(); ++i){
		for (int j = 0; j < the_displayed_solns[i].size(); ++j){
		  std::cout << the_displayed_solns[i][j] << "\n";
		}
		std::cout << "\n";
	      }

}



void RunMapleScript(std::string filename){
  std::stringstream myss4304;
  myss4304 << "maple -F " << filename << ".maple";
  system(myss4304.str().c_str());

}



void OutputOriginalVars(Variable* All_Variable_Ptr, int n){
  std::cout << "The original variables are: \n";
  for (int i = 0; i < n; ++i){
    std::cout << All_Variable_Ptr[i] << "\n";
  }
}
